! This file is part of I.S.A.A.C.S.
!
! I.S.A.A.C.S. is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! I.S.A.A.C.S. is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with I.S.A.A.C.S.  If not, see <http://www.gnu.org/licenses/>.

LOGICAL FUNCTION ALLOCPRIMS()

!
! Memory allocation for primitive and strong ring statistics
!

USE PARAMETERS

IMPLICIT NONE

if(allocated(CPAT)) deallocate(CPAT)
allocate(CPAT(NNA), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: CPAT"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if(allocated(VPAT)) deallocate(VPAT)
allocate(VPAT(NNA,MAXN), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: VPAT"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(APNA)) deallocate(APNA)
allocate(APNA(TAILLD), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: APNA"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(PNA)) deallocate(PNA)
allocate(PNA(TAILLD,TAILLD,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: PNA"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(MAXPNA)) deallocate(MAXPNA)
allocate(MAXPNA(TAILLD,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: MAXPNA"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(MINPNA)) deallocate(MINPNA)
allocate(MINPNA(TAILLD,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: MINPNA"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(MATDIST)) deallocate(MATDIST)
allocate(MATDIST(NNA), STAT=ERR)
if (ERR .ne. 0)then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: MATDIST"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(CHK)) deallocate(CHK)
allocate(CHK(NNA), STAT=ERR)
if (ERR .ne. 0)then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: CHK"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(PRINGORD)) deallocate(PRINGORD)
allocate(PRINGORD(NUMA*10,TAILLE_REF), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: PRINGORD"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(RINGORD)) deallocate(RINGORD)
allocate(RINGORD(TAILLD,NUMA,TAILLD,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: RINGORD"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(RINGSAVED)) deallocate(RINGSAVED)
allocate(RINGSAVED(TAILLD,NUMA,TAILLD), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: RINGSAVED"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(PRINGSAV)) deallocate(PRINGSAV)
allocate(PRINGSAV(NUMA*10,TAILLE_REF), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: PRINGSAV"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(NPRING)) deallocate(NPRING)
allocate(NPRING(NNA), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: NPRING"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(NRING)) deallocate(NRING)
allocate(NRING(TAILLD,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: NRING"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(NIRR)) deallocate(NIRR)
allocate(NIRR(TAILLD,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: NIRR"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(INDRING)) deallocate(INDRING)
allocate(INDRING(TAILLD,NUMA,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: INDRING"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(INDR)) deallocate(INDR)
allocate(INDR(2,NUMA), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: INDR"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(PRING)) deallocate(PRING)
allocate(PRING(TAILLD,NTLT), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: PRING"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(QUEUE)) deallocate(QUEUE)
allocate(QUEUE(NNA), STAT=ERR)
if (ERR .ne. 0)then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: QUEUE"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(TOTEST)) deallocate(TOTEST)
allocate(TOTEST(TAILLD), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: TOTEST"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif
if (allocated(TOTEST2)) deallocate(TOTEST2)
allocate(TOTEST2(TAILLD), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCPRIMS"//CHAR(0), "Table: TOTEST2"//CHAR(0))
  ALLOCPRIMS=.false.
  goto 001
endif

do i=1, TAILLD
  do j=1, NS
   MAXPNA(i,j)=0
   MINPNA(i,j)=0
  enddo
  do j=1, TAILLD
    do k=1, NS
      PNA(i,j,k)=0
    enddo
  enddo
enddo

do i=1, TAILLD
  do j=1, NS
    NRING(i,j)=0
    NIRR(i,j)=0
  enddo
  do j=1, NTLT
    PRING(i,j)=0
  enddo
enddo

do i=1, TAILLD
do j=1, NUMA
do k=1, TAILLD
do l=1, NS
  RINGORD(i,j,k,l)=0
enddo
enddo
enddo
enddo

do i=1, TAILLD
do j=1, NUMA
do k=1, NS
  INDRING(i,j,k)=0
enddo
enddo
enddo

if (CALC_STRINGS) then

  if (allocated(CHK2)) deallocate(CHK2)
  allocate(CHK2(NNA), STAT=ERR)
  if (ERR .ne. 0)then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCPRIMS"//CHAR(0), "Table: CHK2"//CHAR(0))
    ALLOCPRIMS=.false.
    goto 001
  endif
  if (allocated(SPNA)) deallocate(SPNA)
  allocate(SPNA(TAILLD), STAT=ERR)
  if (ERR .ne. 0) then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCPRIMS"//CHAR(0), "Table: SPNA"//CHAR(0))
    ALLOCPRIMS=.false.
    goto 001
  endif
  if (allocated(SNA)) deallocate(SNA)
  allocate(SNA(TAILLD,TAILLD,NS), STAT=ERR)
  if (ERR .ne. 0) then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCPRIMS"//CHAR(0), "Table: SNA"//CHAR(0))
    ALLOCPRIMS=.false.
    goto 001
  endif
  if (allocated(MAXSNA)) deallocate(MAXSNA)
  allocate(MAXSNA(TAILLD,NS), STAT=ERR)
  if (ERR .ne. 0) then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCPRIMS"//CHAR(0), "Table: MAXSNA"//CHAR(0))
    ALLOCPRIMS=.false.
    goto 001
  endif
  if (allocated(MINSNA)) deallocate(MINSNA)
  allocate(MINSNA(TAILLD,NS), STAT=ERR)
  if (ERR .ne. 0) then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCPRIMS"//CHAR(0), "Table: MINSNA"//CHAR(0))
    ALLOCPRIMS=.false.
    goto 001
  endif
  if (allocated(SRINGORD)) deallocate(SRINGORD)
  allocate(SRINGORD(TAILLD,NUMA,TAILLD,NS), STAT=ERR)
  if (ERR .ne. 0) then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCPRIMS"//CHAR(0), "Table: SRINGORD"//CHAR(0))
    ALLOCPRIMS=.false.
    goto 001
  endif
  if (allocated(SRINGSAVED)) deallocate(SRINGSAVED)
  allocate(SRINGSAVED(TAILLD,NUMA,TAILLD), STAT=ERR)
  if (ERR .ne. 0) then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCPRIMS"//CHAR(0), "Table: SRINGSAVED"//CHAR(0))
    ALLOCPRIMS=.false.
    goto 001
  endif
  if (allocated(SRING)) deallocate(SRING)
  allocate(SRING(TAILLD,NTLT), STAT=ERR)
  if (ERR .ne. 0) then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCPRIMS"//CHAR(0), "Table: SRING"//CHAR(0))
    ALLOCPRIMS=.false.
    goto 001
  endif
  if (allocated(SNRING)) deallocate(SNRING)
  allocate(SNRING(TAILLD,NS), STAT=ERR)
  if (ERR .ne. 0) then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCPRIMS"//CHAR(0), "Table: SNRING"//CHAR(0))
    ALLOCPRIMS=.false.
    goto 001
  endif
  if (allocated(SNIRR)) deallocate(SNIRR)
  allocate(SNIRR(TAILLD,NS), STAT=ERR)
  if (ERR .ne. 0) then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCPRIMS"//CHAR(0), "Table: SNIRR"//CHAR(0))
    ALLOCPRIMS=.false.
    goto 001
  endif
  if (allocated(STRRNG)) deallocate(STRRNG)
  allocate(STRRNG(TAILLD), STAT=ERR)
  if (ERR .ne. 0) then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCPRIMS"//CHAR(0), "Table: STRRNG"//CHAR(0))
    ALLOCPRIMS=.false.
    goto 001
  endif
  if (allocated(INDSRING)) deallocate(INDSRING)
  allocate(INDSRING(TAILLD,NUMA,NS), STAT=ERR)
  if (ERR .ne. 0) then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCPRIMS"//CHAR(0), "Table: INDSRING"//CHAR(0))
    ALLOCPRIMS=.false.
    goto 001
  endif
  if (allocated(INDSR)) deallocate(INDSR)
  allocate(INDSR(TAILLD,NUMA), STAT=ERR)
  if (ERR .ne. 0) then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCPRIMS"//CHAR(0), "Table: INDSR"//CHAR(0))
    ALLOCPRIMS=.false.
    goto 001
  endif

  do i=1, TAILLD
    do j=1, NS
      MAXSNA(i,j)=0
      MINSNA(i,j)=0
    enddo
    do j=1, TAILLD
      do k=1, NS
        SNA(i,j,k)=0
      enddo
    enddo
  enddo

  do i=1, TAILLD
    do j=1, NS
      SNRING(i,j)=0
      SNIRR(i,j)=0
    enddo
    do j=1, NTLT
      SRING(i,j)=0
    enddo
  enddo

  do i=1, TAILLD
  do j=1, NUMA
  do k=1, TAILLD
  do l=1, NS
    SRINGORD(i,j,k,l)=0
  enddo
  enddo
  enddo
  enddo

  do i=1, TAILLD
  do j=1, NUMA
  do k=1, NS
    INDSRING(i,j,k)=0
  enddo
  enddo
  enddo

endif

if (FACTATPNA) then
  if (allocated(ATPNA)) deallocate(ATPNA)
  allocate(ATPNA(TAILLD,NTLT,NS), STAT=ERR)
  if (ERR .ne. 0) then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCPRIMS"//CHAR(0), "Table: ATPNA"//CHAR(0))
    ALLOCPRIMS=.false.
    goto 001
  endif
  do i=1, TAILLD
    do j=1, NTLT
      do k=1, NS
        ATPNA(i,j,k)=0
      enddo
    enddo
  enddo
  if (CALC_STRINGS) then
    if (allocated(STPNA)) deallocate(STPNA)
    allocate(STPNA(TAILLD,NTLT,NS), STAT=ERR)
    if (ERR .ne. 0) then
      call show_error ("Impossible to allocate memory"//CHAR(0), &
                       "Function: ALLOCPRIMS"//CHAR(0), "Table: STPNA"//CHAR(0))
      ALLOCPRIMS=.false.
      goto 001
    endif
    do i=1, TAILLD
      do j=1, NTLT
        do k=1, NS
          STPNA(i,j,k)=0
        enddo
      enddo
    enddo
  endif
endif

ALLOCPRIMS=.true.

001 continue

END FUNCTION
