! This file is part of I.S.A.A.C.S.
!
! I.S.A.A.C.S. is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! I.S.A.A.C.S. is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with I.S.A.A.C.S.  If not, see <http://www.gnu.org/licenses/>.

LOGICAL FUNCTION ALLOCRINGS()

!
! Memory allocation for ring statistics
!

USE PARAMETERS

IMPLICIT NONE

if(allocated(RPAT)) deallocate(RPAT)
allocate(RPAT(NA), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: RPAT"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif
if(allocated(CPAT)) deallocate(CPAT)
allocate(CPAT(NA), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: CPAT"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif
if(allocated(VPAT)) deallocate(VPAT)
allocate(VPAT(NA,MAXN), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: VPAT"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif

if(allocated(RES_LIST)) deallocate(RES_LIST)
allocate(RES_LIST(TAILLD), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: RES_LIST"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif
if(allocated(APNA)) deallocate(APNA)
allocate(APNA(TAILLD), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: APNA"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif
if(allocated(NRING)) deallocate(NRING)
allocate(NRING(TAILLD,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: NRING"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif
if(allocated(NIRR)) deallocate(NIRR)
allocate(NIRR(TAILLD,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: NIRR"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif
if (allocated(INDR)) deallocate(INDR)
allocate(INDR(TAILLD,NUMA), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: INDR"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif
if (allocated(NIRRAT)) deallocate(NIRRAT)
allocate(NIRRAT(TAILLD,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: NIRRAT"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif
if (allocated(PNA)) deallocate(PNA)
allocate(PNA(TAILLD,TAILLD,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: PNA"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif
if (allocated(MAXPNA)) deallocate(MAXPNA)
allocate(MAXPNA(TAILLD,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: MAXPNA"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif
if (allocated(MINPNA)) deallocate(MINPNA)
allocate(MINPNA(TAILLD,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: MINPNA"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif
if (allocated(INDRAT)) deallocate(INDRAT)
allocate(INDRAT(TAILLD,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: INDRAT"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif
if (allocated(INDRING)) deallocate(INDRING)
allocate(INDRING(TAILLD,NUMA,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: INDRING"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif
if (allocated(LIRR)) deallocate(LIRR)
allocate(LIRR(TAILLD,NUMA,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: LIRR"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif
if (allocated(RINGSAVED)) deallocate(RINGSAVED)
allocate(RINGSAVED(TAILLD,NUMA,TAILLD), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: RINGSAVED"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif
if (allocated(RINGORD)) deallocate(RINGORD)
allocate(RINGORD(TAILLD,NUMA,TAILLD,NS), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Function: ALLOCRINGS"//CHAR(0), "Table: RINGORD"//CHAR(0))
  ALLOCRINGS=.false.
  goto 001
endif

if (FACTATRING) then
  if (allocated(ATRING)) deallocate(ATRING)
  allocate(ATRING(TAILLD,NTLT,NS), STAT=ERR)
  if (ERR .ne. 0) then

  endif
  do i=1, TAILLD
    do j=1, NTLT
      do k=1, NS
        ATRING(i,j,k)=0
      enddo
    enddo
  enddo
endif

if (DOAMPAT) then
  if (allocated(AMPAT)) deallocate(AMPAT)
  allocate(AMPAT(NTLT,NS), STAT=ERR)
  if (ERR .ne. 0) then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCRINGS"//CHAR(0), "Table: AMPAT"//CHAR(0))
    ALLOCRINGS=.false.
    goto 001
  endif
  do j=1, NTLT
    do k=1, NS
      AMPAT(j,k)=0
    enddo
  enddo
endif

if (FACTATPNA) then
  if (allocated(ATPNA)) deallocate(ATPNA)
  allocate(ATPNA(TAILLD,NTLT,NS), STAT=ERR)
  if (ERR .ne. 0) then
    call show_error ("Impossible to allocate memory"//CHAR(0), &
                     "Function: ALLOCRINGS"//CHAR(0), "Table: ATPNA"//CHAR(0))
    ALLOCRINGS=.false.
    goto 001
  endif
  do i=1, TAILLD
    do j=1, NTLT
      do k=1, NS
        ATPNA(i,j,k)=0
      enddo
    enddo
  enddo
endif

! End of allocation / Initialisation

do i=1, TAILLD
  do j=1, NS
   MAXPNA(i,j)=0
   MINPNA(i,j)=0
  enddo
  do j=1, TAILLD
    do k=1, NS
      PNA(i,j,k)=0
    enddo
  enddo
enddo

do i=1, TAILLD
  do j=1, NS
    NRING(i,j)=0
    NIRR(i,j)=0
    INDRAT(i,j)=0
    NIRRAT(i,j)=0
  enddo
enddo

do i=1, TAILLD
  do j=1, NUMA
    do k=1, NS
      INDRING(i,j,k)=0
    enddo
  enddo
enddo

do i=1, TAILLD
  do j=1, NUMA
    do k=1, TAILLD
      do l=1, NS
        RINGORD(i,j,k,l)=0
      enddo
    enddo
  enddo
enddo

ALLOCRINGS=.true.

001 continue

END FUNCTION
