/* This file is part of I.S.A.A.C.S.

   I.S.A.A.C.S. is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

    I.S.A.A.C.S. is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with I.S.A.A.C.S.  If not, see <http://www.gnu.org/licenses/>. */

#include <gtk/gtk.h>

typedef struct {
  int ndata;
  double * data;
  double cmin[2];
  double cmax[2];
  double axmin[2];
  double axmax[2];
  GtkWidget * plot;
  GtkWidget * button;
  GtkWidget * window;
  int format;
  char * title;
  char * xlabel;
  int aspect;
  int scale[2];
  gboolean xdef;
  gboolean init[2];
  gboolean grid[2];
  gboolean ashow[2];
  gboolean legend;
  gboolean frame;
  gboolean autoscale[2];
  double legpos[2];
  double majt[2];
  int mint[2];
  GdkColor datacolor;
  GdkColor backcolor;
  GdkColor framcolor;
  double thickness;
  int dash;
  int glyph;
  double gsize;
  int gfreq;
  int cstart;
  int cend;
  int extra;
  int * extrasets;
  double * extrathick;
  int * extradash;
  int * extraglyph;
  int * extraspect;
  double * extragsize;
  int * extragfreq;
  GdkColor * extracolor;
  char * cfile;
} curve;

extern curve ** curves;

void setup_xaxis_linear (int * thexdata, gboolean * dogrid);

G_MODULE_EXPORT void show_curve (GtkWidget * grwdget, gpointer curve);
G_MODULE_EXPORT void on_viewcurve_toggled (GtkToggleButton * Button, gpointer data);

G_MODULE_EXPORT void curve_hide (GtkWidget * thecurve, GdkEvent * event, gpointer data);
GtkWidget * create_Curve (char * namecurve, int * idcurve);
void addcurwidget (char * wname, int * wid, int * pid, GtkTable * tablegtk);

void save_curve_ (int * interv, double datacurve[* interv], int * id);

G_MODULE_EXPORT void write_curve (GtkWidget * butcurve, gpointer idata);
void hide_curves (int * wstart, int * wend);

G_MODULE_EXPORT void save_image (GtkWidget * curve, gpointer cdata);

void update_curve (gpointer curve);

G_MODULE_EXPORT void edit_image (GtkWidget * curve, gpointer cdata);
