/* This file is part of I.S.A.A.C.S.

   I.S.A.A.C.S. is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

    I.S.A.A.C.S. is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with I.S.A.A.C.S.  If not, see <http://www.gnu.org/licenses/>. */

#include <gtk/gtk.h>

#ifdef OSX
#include <gtkosxapplication.h>
#endif

#ifdef G_OS_WIN32
gchar * PACKAGE_PREFIX = NULL;
gchar * PACKAGE_DATA_DIR = NULL;
gchar * PACKAGE_LOCALE_DIR = NULL;
gchar * PACKAGE_XML_FILE = NULL;
gchar * PACKAGE_LOGO = NULL;
gchar * PACKAGE_PNG = NULL;
gchar * PACKAGE_PDF = NULL;
gchar * PACKAGE_SVG = NULL;
gchar * PACKAGE_VOID = NULL;
gchar * PACKAGE_EDIT = NULL;
gchar * PACKAGE_MOL = NULL;
gchar * IMG_PIX = NULL;
#endif

#ifdef OSX
GtkosxApplication * IsaacsOSX;
#endif

GtkBuilder * BuilderGtk = NULL;
GError * GtkErr = NULL;
GdkPixbuf * THEMOL = NULL;

char * untime[6] = {"t [fs]", "t [ps]", "t [ns]", "t [µs]", "t [ms]", " "};
char * coordfile = NULL;
char * typefile = NULL;
char * bondfile = NULL;
char * trc[5] = {"All rings (no rules)", "Guttman's S.P.", "King's S.P.", "Primitive", "Strong"};
char retl[3] = "\n";
char * ipffile;

gboolean newipf = TRUE;
gboolean apbc = FALSE;
gboolean readata = FALSE;
gboolean fractional = FALSE;
gboolean rprep = TRUE;
gboolean runfrac = FALSE;
gboolean run = FALSE;
gboolean trun = FALSE;
gboolean prun = FALSE;
gboolean grrun = FALSE;
gboolean sqrun = FALSE;
gboolean skrun = FALSE;
gboolean gqrun = FALSE;
gboolean bdrun = FALSE;
gboolean brun = FALSE;
gboolean angrun = FALSE;
gboolean msdrun = FALSE;
gboolean ringrun = FALSE;
gboolean shrun = FALSE;
gboolean bvrun = FALSE;
gboolean dmtx = FALSE;
gboolean changedpbc = FALSE;

int nformats = 7;
int nspec = 0;
int natomes = 0;
int steps = 0;
int tunit = 0;
int numwid =0;
int numgr = 0;
int numsq = 0;
int numsk = 0;
int numgq = 0;
int numbd = 0;
int numan = 0;
int nummsd = 0;
int numri = 0;
int numsh = 0;
int num_delta_r = 0;
int num_delta_q = 0;
int num_delta_k = 0;
int num_delta_rq = 0;
int num_delta_a = 0;
int num_delta_d = 0;
int num_ring = 80;
int vlmax = 0;
int spsh = 0;
int idsh = 0;
int spbv = 0;
int idbv = 0;
int search = 0;
int ringsize = 0;
int maxring = 0;
int initnode = 0;
int onlyabab = 0;
int homo = 0;
int tfrac = 0;
int wtfrac = 0;
int ndtbs = 0;

double qlim = 15;
double plim = 1.0;
double delta_r = 0.0;
double delta_q = 0.0;
double delta_k = 0.0;
double delta_rq = 0.0;
double delta_t = 0.0;
double delta_d = 0.0;
double delta_a = 0.0;
double dmax = 0.0;
double bdmax = 0.0;
double bdmin = 0.0;
double opac = 0.75;
double alpha = 0.0;
int cell = 0;
double cvect[3][3] = {{0.0,0.0,0.0},{0.0,0.0,0.0},{0.0,0.0,0.0}};
double langles[3] = {0.0, 0.0, 0.0};
double vmod[3] = {0.0, 0.0, 0.0};
double pi =3.141592653589793238462643383279502884197;
double qmax = 0.0;
double qmin = 0.0;
double kmax = 0.0;
double kmin = 0.0;
double sqfact = 0.0;
double skfact = 0.0;
double grfact = 0.0;
double gqfact = 0.0;
double qmaxfft = 0.0;
double R0 = 0.0;
double B = 0.0;
double N = 0.0;
double xlim = 1000.0;
double ylim = 1000.0;

int * idsk = NULL;
int * atid = NULL;
int * radid = NULL;
char ** label = NULL;
char ** elt_name = NULL;
double * nscatt = NULL;
double * xscatt = NULL;
double * amass = NULL;
double * rad = NULL;
double ** cutoffs = NULL;
double grtotcutoff = 0.0;

GtkWidget ** shbox = NULL;
GtkWidget ** bvbox = NULL;
GtkWidget * specbox = NULL;
GtkWidget * bspeca = NULL;
GtkWidget * bspecb = NULL;
GtkWidget * aspeca = NULL;
GtkWidget * aspecb = NULL;
GtkWidget * rspeca = NULL;
GtkWidget * rspecb = NULL;
GtkWidget * rispec = NULL;
GtkWidget * shspec = NULL;
GtkWidget * bvspec = NULL;
GtkTable * tablegtkgr = NULL;
GtkFixed * fixedgtkgr = NULL;
GtkTable * tablegtksq = NULL;
GtkFixed * fixedgtksq = NULL;
GtkTable * tablegtksk = NULL;
GtkFixed * fixedgtksk = NULL;
GtkTable * tablegtkgq = NULL;
GtkFixed * fixedgtkgq = NULL;
GtkTable * tablegtkbd = NULL;
GtkFixed * fixedgtkbd = NULL;
GtkTable * tablegtkan = NULL;
GtkFixed * fixedgtkan = NULL;
GtkTable * tablegtkms = NULL;
GtkFixed * fixedgtkms = NULL;
GtkTable * tablegtkri = NULL;
GtkFixed * fixedgtkri = NULL;
GtkTable * tablegtksh = NULL;
GtkFixed * fixedgtksh = NULL;
GtkWidget * progressbar = NULL;

void update_entry_int (GtkEntry * entry, int * intval)
{
  gchar * value;
  value = g_strdup_printf("%d", * intval);
  gtk_entry_set_text (entry, (const gchar *)value);
  g_free(value);
}

void update_entry_double (GtkEntry * entry, double * doubleval)
{
  gchar * value;
  value = g_strdup_printf("%f", * doubleval);
  gtk_entry_set_text (entry, (const gchar *)value);
  g_free(value);
}

