/* This file is part of I.S.A.A.C.S.

   I.S.A.A.C.S. is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

    I.S.A.A.C.S. is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with I.S.A.A.C.S.  If not, see <http://www.gnu.org/licenses/>. */

#include <gtk/gtk.h>

#ifdef G_OS_WIN32
#  include <windows.h>
#else
#  define max(a,b) (a>=b?a:b)
#  define min(a,b) (a<=b?a:b)
#endif

#ifdef OSX
#include <gtkosxapplication.h>
#endif

#ifdef G_OS_WIN32
extern gchar * PACKAGE_PREFIX;
extern gchar * PACKAGE_DATA_DIR;
extern gchar * PACKAGE_LOCALE_DIR;
extern gchar * PACKAGE_XML_FILE;
extern gchar * PACKAGE_LOGO;
extern gchar * PACKAGE_PNG;
extern gchar * PACKAGE_PDF;
extern gchar * PACKAGE_SVG;
extern gchar * PACKAGE_VOID;
extern gchar * PACKAGE_EDIT;
extern gchar * PACKAGE_MOL;
extern gchar * IMG_PIX;
#endif

#ifdef OSX
extern GtkosxApplication * IsaacsOSX;
#endif

extern GtkBuilder * BuilderGtk;
extern GError * GtkErr;
extern GdkPixbuf * THEMOL;

extern char * untime[6];
extern char * coordfile;
extern char * typefile;
extern char * bondfile;
extern char * trc[5];
extern char retl[3];
extern char * ipffile;

extern gboolean newipf;
extern gboolean apbc;
extern gboolean readata;
extern gboolean fractional;
extern gboolean rprep;
extern gboolean runfrac;
extern gboolean run;
extern gboolean prun;
extern gboolean trun;
extern gboolean grrun;
extern gboolean sqrun;
extern gboolean skrun;
extern gboolean gqrun;
extern gboolean brun;
extern gboolean bdrun;
extern gboolean angrun;
extern gboolean msdrun;
extern gboolean ringrun;
extern gboolean shrun;
extern gboolean bvrun;
extern gboolean dmtx;
extern gboolean changedpbc;

extern int nformats;
extern int nspec;
extern int natomes;
extern int steps;
extern int tunit;
extern int numwid;
extern int numgr;
extern int numsq;
extern int numsk;
extern int numgq;
extern int numbd;
extern int numan;
extern int nummsd;
extern int numri;
extern int numsh;
extern int num_delta_r;
extern int num_delta_q;
extern int num_delta_k;
extern int num_delta_rq;
extern int num_delta_d;
extern int num_delta_a;
extern int num_ring;
extern int vlmax;
extern int idsh;
extern int spsh;
extern int spbv;
extern int idbv;
extern int search;
extern int ringsize;
extern int maxring;
extern int initnode;
extern int onlyabab;
extern int homo;
extern int tfrac;
extern int wtfrac;
extern int ndtbs;

extern double qlim;
extern double plim;
extern double delta_r;
extern double delta_q;
extern double delta_k;
extern double delta_rq;
extern double delta_t;
extern double delta_d;
extern double delta_a;
extern double dmax;
extern double bdmax;
extern double bdmin;
extern double opac;
extern double alpha;
extern int cell;
extern double cvect[3][3];
extern double langles[3];
extern double vmod[3];
extern double pi;
extern double qmax;
extern double qmin;
extern double kmax;
extern double kmin;
extern double sqfact;
extern double skfact;
extern double grfact;
extern double gqfact;
extern double qmaxfft;
extern double R0;
extern double B;
extern double N;

extern double xlim;
extern double ylim;

extern int * idsk;
extern int * atid;
extern int * radid;
extern char ** label;
extern char ** elt_name;
extern double * nscatt;
extern double * xscatt;
extern double * amass;
extern double * rad;
extern double ** cutoffs;
extern double grtotcutoff;

extern GtkWidget ** shbox;
extern GtkWidget ** bvbox;
extern GtkWidget * specbox;
extern GtkWidget * bspeca;
extern GtkWidget * bspecb;
extern GtkWidget * aspeca;
extern GtkWidget * aspecb;
extern GtkWidget * rspeca;
extern GtkWidget * rspecb;
extern GtkWidget * rispec;
extern GtkWidget * shspec;
extern GtkWidget * bvspec;
extern GtkTable * tablegtkgr;
extern GtkFixed * fixedgtkgr;
extern GtkTable * tablegtksq;
extern GtkFixed * fixedgtksq;
extern GtkTable * tablegtksk;
extern GtkFixed * fixedgtksk;
extern GtkTable * tablegtkgq;
extern GtkFixed * fixedgtkgq;
extern GtkTable * tablegtkbd;
extern GtkFixed * fixedgtkbd;
extern GtkTable * tablegtkan;
extern GtkFixed * fixedgtkan;
extern GtkTable * tablegtkms;
extern GtkFixed * fixedgtkms;
extern GtkTable * tablegtkri;
extern GtkFixed * fixedgtkri;
extern GtkTable * tablegtksh;
extern GtkFixed * fixedgtksh;
extern GtkWidget * progressbar;

void update_entry_int (GtkEntry * entry, int * intval);
void update_entry_double (GtkEntry * entry, double * doubleval);
