! This file is part of I.S.A.A.C.S.
!
! I.S.A.A.C.S. is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! I.S.A.A.C.S. is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with I.S.A.A.C.S.  If not, see <http://www.gnu.org/licenses/>.

INTEGER FUNCTION initrings (VRINGS, VTAILLD, VTLT, VNUMA, IFHOMO)

!
! Initialization of the ring statistics
! The key variable is NUMA see in the following lines
!

USE PARAMETERS

INTEGER, INTENT(IN) :: VRINGS, VTAILLD, VTLT, VNUMA, IFHOMO
DOUBLE PRECISION :: pro

INTERFACE
  LOGICAL FUNCTION ALLOCRINGS()
  END FUNCTION
END INTERFACE
INTERFACE
  LOGICAL FUNCTION ALLOCPRIMS()
  END FUNCTION
END INTERFACE
INTERFACE
  INTEGER FUNCTION RINGS()
  END FUNCTION
END INTERFACE
INTERFACE
  INTEGER FUNCTION RINGS2()
  END FUNCTION
END INTERFACE
INTERFACE
  INTEGER FUNCTION RINGS3()
  END FUNCTION
END INTERFACE
INTERFACE
  INTEGER FUNCTION RINGS4()
  END FUNCTION
END INTERFACE
INTERFACE
  INTEGER FUNCTION TRINGS()
  END FUNCTION
END INTERFACE
INTERFACE
  INTEGER FUNCTION PRIM_DIJKSTRA()
  END FUNCTION
END INTERFACE

if (VTLT .eq. 0) then
  TLT=NSP+1
else
  TLT=VTLT
endif
NUMA=VNUMA
NTLT=NBSPBS(TLT)
TAILLE_REF=VTAILLD
TAILLD=VTAILLD*2

TBR=.false.
ALC=.false.

! In the following lines the NUMA variable
! gives the 'average' number of rings per size and per step
! this variable depends on the type of rings, of the system studied as well
! as of the search depth.
! NUMA is used as a reference to allocate almost all tabs during rings
! search and analysis. NUMA is a key variable - tweak with caution !

if (VRINGS.eq.1 .or. VRINGS.eq.2) then
  DOAMPAT=.true.
else
  DOAMPAT=.false.
endif

if (VRINGS.le.2) then
  if (.not.ALLOCRINGS()) then
    initrings=0
    goto 001
  endif
endif

if (VRINGS .eq. 0) then
! Here NUMA can be very big
  initrings=TRINGS()
endif

if (VRINGS .eq. 1) then
  if (IFHOMO .eq.1) then
    initrings=RINGS2()
  else
    initrings=RINGS4()
  endif
endif

if (VRINGS .eq. 2) then
  if (IFHOMO .eq.1) then
    initrings=RINGS()
  else
    initrings=RINGS3()
  endif
endif

if (VRINGS >  2) then
  CALC_PRINGS=.true.
  if (VRINGS .eq. 4) CALC_STRINGS=.true.
  if (.not.ALLOCPRIMS()) then
    initrings=0
    goto 001
  endif
  initrings=PRIM_DIJKSTRA()
endif

if (NS.gt.1 .or. (NS.eq.1 .and. TAILLD.ge.20)) then
  pro=0.0d0
  call setprogress (pro)
endif

001 continue

END FUNCTION
