! This file is part of I.S.A.A.C.S.
!
! I.S.A.A.C.S. is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! I.S.A.A.C.S. is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with I.S.A.A.C.S.  If not, see <http://www.gnu.org/licenses/>.

#if defined (HAVE_CONFIG_H)
#  include <config.h>
#endif
#include "version.h"

SUBROUTINE isaacs_init

USE PARAMETERS

implicit none

call DATE_AND_TIME(sdate, stime, szone)
write (6, 001)
write (6, 002) VERSION
write (6, 003) sdate(7:8), sdate(5:6), sdate(1:4), stime(1:2), stime(3:4), stime(5:6), szone(1:3), szone(4:5)
write (6, 001)

001 FORMAT (/,"***************************************************************",/)
002 FORMAT (22x,"I.S.A.A.C.S. v",A4," Start",/)
003 FORMAT (5X,"Started on ",2(A2,"/"),A4," at ",2(A2,":"),A2," MET ",A3,":",A2," from GMT")

END SUBROUTINE

SUBROUTINE isaacs_end

USE PARAMETERS

call isaacs_free

call DATE_AND_TIME(edate, etime, ezone)

write (6, 001)
write (6, 002) VERSION
write (6, 003) edate(7:8), edate(5:6), edate(1:4), etime(1:2), etime(3:4), etime(5:6), ezone(1:3), ezone(4:5)
write (6, 001)
write (6, 004)

001 FORMAT (/,"***************************************************************",/)
002 FORMAT (22x,"I.S.A.A.C.S. v",A4," Stopped",/)
003 FORMAT (5X,"Stopped on ",2(A2,"/"),A4," at ",2(A2,":"),A2," MET ",A3,":",A2," from GMT")

004 FORMAT (/,"<I.S.A.A.C.S.>  Copyright (C) <2009-2018>  <Sébastien Le Roux - Valeri Petkov>", /, &
               "This program comes with ABSOLUTELY NO WARRANTY; see ""COPYING"" for details", /, &
               "This is free software, and you are welcome to redistribute it", /, &
               "under certain conditions; see ""COPYING"" for details.")


END SUBROUTINE

SUBROUTINE isaacs_free

USE PARAMETERS

! deallocation of possibly remaining data

if (allocated(FULLPOS)) deallocate(FULLPOS)
if (allocated(TAB_OF_TYPE)) deallocate(TAB_OF_TYPE)
if (allocated(XGrTOT)) deallocate(XGrTOT)
if (allocated(GrTOT)) deallocate(GrTOT)
if (allocated(Gr_CUT)) deallocate(Gr_CUT)
if (allocated(Gr_ij)) deallocate(Gr_ij)
if (allocated(LOT)) deallocate(LOT)
if (allocated(NBSPBS)) deallocate(NBSPBS)
if (allocated(TL)) deallocate(TL)
if (allocated(ATOMID)) deallocate(ATOMID)
if (allocated(ELEMID)) deallocate(ELEMID)
if (allocated(NSCATTL)) deallocate(NSCATTL)
if (allocated(XSCATTL)) deallocate(XSCATTL)
if (allocated(MASS)) deallocate(MASS)
if (allocated(RVDW)) deallocate(RVDW)
if (allocated(VOL_DENSITY)) deallocate(VOL_DENSITY)
if (allocated(Xi)) deallocate(Xi)
if (allocated(INDEX_FORM)) deallocate(INDEX_FORM)
if (allocated(LISTE_GEOMSA)) deallocate(LISTE_GEOMSA)
if (allocated(Q_POINT)) deallocate(Q_POINT)
if (allocated(K_POINT)) deallocate(K_POINT)
if (allocated(R_POINT)) deallocate(R_POINT)
if (allocated(F_POINT)) deallocate(F_POINT)

END SUBROUTINE
