! This file is part of I.S.A.A.C.S.
!
! I.S.A.A.C.S. is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! I.S.A.A.C.S. is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with I.S.A.A.C.S.  If not, see <http://www.gnu.org/licenses/>.

MODULE MENDELEIEV

INTEGER :: MAXE=106

CHARACTER (LEN=2), DIMENSION(106), PARAMETER :: ATSYM=(/ &
  'H ', 'He', 'Li', 'Be', 'B ', 'C ', 'N ', 'O ', 'F ',  &
  'Ne', 'Na', 'Mg', 'Al', 'Si', 'P ', 'S ', 'Cl', 'Ar',  &
  'K ', 'Ca', 'Sc', 'Ti', 'V ', 'Cr', 'Mn', 'Fe', 'Co',  &
  'Ni', 'Cu', 'Zn', 'Ga', 'Ge', 'As', 'Se', 'Br', 'Kr',  &
  'Rb', 'Sr', 'Y ', 'Zr', 'Nb', 'Mo', 'Tc', 'Ru', 'Rh',  &
  'Pd', 'Ag', 'Cd', 'In', 'Sn', 'Sb', 'Te', 'I ', 'Xe',  &
  'Cs', 'Ba', 'La', 'Ce', 'Pr', 'Nd', 'Pm', 'Sm', 'Eu',  &
  'Gd', 'Tb', 'Dy', 'Ho', 'Er', 'Tm', 'Yb', 'Lu', 'Hf',  &
  'Ta', 'W ', 'Re', 'Os', 'Ir', 'Pt', 'Au', 'Hg', 'Tl',  &
  'Pb', 'Bi', 'Po', 'At', 'Rn', 'Fr', 'Ra', 'Ac', 'Th',  &
  'Pa', 'U ', 'Np', 'Pu', 'Am', 'Cm', 'Bk', 'Cf', 'Es',  &
  'Fm', 'Md', 'No', 'Lr', 'Rf', 'Ha', 'D ' /)

CHARACTER (LEN=14), DIMENSION(106), PARAMETER :: ELEMENT=(/ &
  'Hydrogen      ', 'Helium        ', 'Lithium       ', 'Beryllium     ', &
  'Boron         ', 'Carbon        ', 'Nitrogen      ', 'Oxygen        ', &
  'Fluorine      ', 'Neon          ', 'Sodium        ', 'Magnesium     ', &
  'Aluminum      ', 'Silicon       ', 'Phosphorus    ', 'Sulfur        ', &
  'Chlorine      ', 'Argon         ', 'Potassium     ', 'Calcium       ', &
  'Scandium      ', 'Titanium      ', 'Vanadium      ', 'Chromium      ', &
  'Manganese     ', 'Iron          ', 'Cobalt        ', 'Nickel        ', &
  'Copper        ', 'Zinc          ', 'Gallium       ', 'Germanium     ', &
  'Arsenic       ', 'Selenium      ', 'Bromine       ', 'Krypton       ', &
  'Rubidium      ', 'Strontium     ', 'Yttrium       ', 'Zirconium     ', &
  'Niobium       ', 'Molybdenum    ', 'Technetium    ', 'Ruthenium     ', &
  'Rhodium       ', 'Palladium     ', 'Silver        ', 'Cadmium       ', &
  'Indium        ', 'Tin           ', 'Antimony      ', 'Tellurium     ', &
  'Iodine        ', 'Xenon         ', 'Caesium       ', 'Barium        ', &
  'Lanthanum     ', 'Cerium        ', 'Praseodymium  ', 'Neodymium     ', &
  'Promethium    ', 'Samarium      ', 'Europium      ', 'Gadolinium    ', &
  'Terbium       ', 'Dysprosium    ', 'Holmium       ', 'Erbium        ', &
  'Thulium       ', 'Ytterbium     ', 'Lutetium      ', 'Hafnium       ', &
  'Tantalum      ', 'Tungsten      ', 'Rhenium       ', 'Osmium        ', &
  'Iridium       ', 'Platinum      ', 'Gold          ', 'Mercury       ', &
  'Thallium      ', 'Lead          ', 'Bismuth       ', 'Polonium      ', &
  'Astatine      ', 'Radon         ', 'Francium      ', 'Radium        ', &
  'Actinium      ', 'Thorium       ', 'Protactinium  ', 'Uranium       ', &
  'Neptunium     ', 'Plutonium     ', 'Americium     ', 'Curium        ', &
  'Berkelium     ', 'Californium   ', 'Einsteinium   ', 'Fermium       ', &
  'Mendelevium   ', 'Nobelium      ', 'Lawrencium    ', 'Rutherfordium ', &
  'Hassium       ', 'Deuterium     ' /)

DOUBLE PRECISION, DIMENSION(106), PARAMETER :: AMASS=(/ &
  1.01, 4.00, 6.941, 9.01, 10.81, 12.01, 14.01, 16.00, &
  19.00, 20.18, 22.99, 24.31, 26.98, 28.09, 30.97, &
  32.07, 35.45, 39.95, 39.10, 40.08, 44.96, 47.88, &
  50.94, 52.00, 54.94, 55.85, 58.93, 58.69, 63.55, &
  65.39, 69.72, 72.61, 74.92, 78.96, 79.90, 83.80, &
  85.47, 87.62, 88.91, 91.22, 92.91, 95.94, 98.00, &
  101.07, 102.91, 106.42, 107.87, 112.41, 114.82, &
  118.71, 121.75, 127.60, 126.91, 131.29, 132.91, &
  137.33, 138.91, 140.12, 140.91, 144.24, 145.00, &
  150.36, 151.97, 157.25, 158.93, 162.50, 164.93, &
  167.26, 168.93, 173.04, 174.97, 178.49, 180.95, &
  183.85, 186.21, 190.20, 192.22, 195.08, 196.97, &
  200.59, 204.38, 207.20, 208.98, 209.00, 210.00, &
  222.00, 223.00, 226.03, 227.03, 232.04, 231.04, &
  238.03, 237.05, 244.00, 243.00, 247.00, 247.00, &
  251.00, 252.00, 257.00, 258.00, 259.00, 260.00, &
  261.00, 260.00, 2.01 /)

! Source: Beatriz Cordero and al.
! in "Covalent radii revisited",
! Dalton Trans., 2008, [DOI: 10.1039/b801115j].
DOUBLE PRECISION, DIMENSION(106), PARAMETER :: ARCOV=(/ &
  0.31, 0.28, 1.28, 0.96, 0.84, 0.76, 0.71, 0.66, 0.57, &
  0.58, 1.66, 1.41, 1.21, 1.11, 1.07, 1.05, 1.02, 1.06, &
  2.03, 1.76, 1.70, 1.60, 1.53, 1.39, 1.39, 1.32, 1.26, &
  1.24, 1.32, 1.22, 1.22, 1.20, 1.19, 1.20, 1.20, 1.16, &
  2.20, 1.95, 1.90, 1.75, 1.64, 1.54, 1.47, 1.46, 1.42, &
  1.39, 1.45, 1.44, 1.42, 1.39, 1.39, 1.38, 1.39, 1.40, &
  2.44, 2.15, 2.07, 2.04, 2.03, 2.01, 1.99, 1.98, 1.98, &
  1.96, 1.94, 1.92, 1.92, 1.89, 1.90, 1.87, 1.87, 1.75, &
  1.70, 1.62, 1.51, 1.44, 1.41, 1.36, 1.36, 1.32, 1.45, &
  1.46, 1.48, 1.40, 1.50, 1.50, 2.60, 2.21, 2.15, 2.06, &
  2.00, 1.96, 1.90, 1.87, 1.80, 1.69, 0.00, 0.00, 0.00, &
  0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.31 /)

! Source: Slater, Journal of Chemical Physics, 41, 3199 (1964).
DOUBLE PRECISION, DIMENSION(106), PARAMETER :: ARION=(/ &
  -0.24, 0.000, 0.900, 0.590, 0.250, 0.300, 1.320, 1.260, &
  1.190, 0.000, 1.160, 0.860, 0.675, 0.400, 0.310, 1.700, &
  1.670, 0.000, 1.520, 1.140, 0.885, 0.745, 0.680, 0.755, &
  0.670, 0.690, 0.790, 0.830, 0.870, 0.880, 0.760, 0.670, &
  0.720, 1.840, 1.820, 0.000, 1.660, 1.320, 1.040, 0.860, &
  0.780, 0.730, 0.700, 0.705, 0.690, 0.755, 1.290, 1.090, &
  0.940, 0.830, 0.740, 2.070, 2.060, 0.000, 1.810, 1.490, &
  1.172, 1.010, 1.130, 1.123, 1.110, 1.098, 1.087, 1.078, &
  1.063, 1.052, 1.041, 1.030, 1.020, 1.008, 1.001, 0.850, &
  0.780, 0.650, 0.670, 0.530, 0.710, 0.710, 0.710, 1.160, &
  1.025, 1.330, 1.170, 0.810, 0.760, 0.000, 1.940, 1.620, &
  1.260, 0.000, 0.920, 1.030, 0.850, 0.850, 1.350, 0.990, &
  0.970, 0.961, 0.000, 0.000, 0.000, 1.240, 0.000, 0.000, &
  0.000, -0.24 /)

! Source: A. Bondi, J. Phys. Chem., 68, 441 (1964).
DOUBLE PRECISION, DIMENSION(106), PARAMETER :: ARVDW=(/ &
  1.20, 1.40, 1.82, 0.00, 0.00, 1.70, 1.55, 1.52, 1.47, &
  1.54, 2.27, 1.73, 0.00, 2.10, 1.80, 1.80, 1.75, 1.88, &
  2.75, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, &
  1.63, 1.40, 1.39, 1.87, 0.00, 1.85, 1.90, 1.85, 2.02, &
  0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, &
  1.63, 1.72, 1.58, 1.93, 2.17, 0.00, 2.06, 1.98, 2.16, &
  0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, &
  0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, &
  0.00, 0.00, 0.00, 0.00, 0.00, 1.75, 1.66, 1.55, 1.96, &
  2.02, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, &
  0.00, 1.86, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, &
  0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 1.20 /)

! Source:
! R D Shannon and C T Prewitt (1969) Acta Cryst. B25:925-946
! R D Shannon (1976) Acta Cryst. A23:751-76A.
DOUBLE PRECISION, DIMENSION(106), PARAMETER :: ARCRY=(/ &
  0.10, 0.00, 0.90, 0.41, 0.25, 0.29, 0.30, 1.21, 1.19, &
  0.00, 1.16, 0.86, 0.53, 0.40, 0.31, 0.43, 1.67, 0.00, &
  1.52, 1.14, 0.89, 0.75, 0.68, 0.76, 0.81, 0.69, 0.54, &
  0.70, 0.71, 0.74, 0.76, 0.53, 0.72, 0.56, 1.82, 0.00, &
  1.66, 1.32, 1.04, 0.86, 0.78, 0.79, 0.79, 0.82, 0.81, &
  0.78, 1.29, 0.92, 0.94, 0.69, 0.90, 1.11, 2.06, 0.62, &
  1.81, 1.49, 1.36, 1.15, 1.32, 1.30, 1.28, 1.10, 1.31, &
  1.08, 1.18, 1.05, 1.04, 1.03, 1.02, 1.13, 1.00, 0.85, &
  0.78, 0.74, 0.77, 0.77, 0.77, 0.74, 1.51, 0.83, 1.03, &
  1.49, 1.17, 1.08, 0.76, 0.00, 1.94, 1.62, 1.26, 1.19, &
  1.09, 0.87, 0.00, 1.00, 1.12, 1.11, 0.00, 0.00, 0.00, &
  0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.04 /)

! Source: http://www.ncnr.nist.gov/resources/n-lengths/
! Neutron News - Sears, Varley F.
! "Neutron scattering lengths and cross sections"
! 1992 - Vol 3, Issue 3, p26-37
! http://www.informaworld.com/10.1080/10448639208218770
DOUBLE PRECISION, DIMENSION(106), PARAMETER :: COHEB=(/ &
       -3.739, 3.26, -1.90, 7.79, 5.304, 6.646, 9.36, &
   5.803, -0.082, 4.566, 3.580, 5.375, 3.349, 4.1491, &
       5.131, 2.847, 9.577, 1.909, 3.67, 4.70, 12.29, &
     -3.438, -0.3824, 3.635, -3.73, 9.45, 2.49, 10.3, &
      7.718, 5.680, 7.288, 8.185, 6.58, 7.970, 6.795, &
     7.81, 7.09, 7.02, 7.75, 7.16, 7.054, 6.715, 6.8, &
  7.03, 5.88, 5.91, 5.922, 5.130, 4.065, 6.225, 5.57, &
      5.80, 5.28, 4.92, 5.42, 5.07, 8.24, 4.84, 4.58, &
     7.69, 12.6, 13.5, 7.22, 6.550, 7.38, 16.9, 8.01, &
      7.79, 7.07 , 12.43, 7.21, 7.7, 6.91, 4.86, 9.2, &
  10.7, 10.6, 9.6, 7.63, 12.692, 8.776, 9.405, 8.532, &
      0.00, 0.00, 0.00, 0.00, 10.0, 0.00, 10.31, 9.1, &
     8.417, 10.55, 0.00, 8.3, 0.00, 0.00, 0.00, 0.00, &
           0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 6.671 /)

END MODULE
