! This file is part of I.S.A.A.C.S.
!
! I.S.A.A.C.S. is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! I.S.A.A.C.S. is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with I.S.A.A.C.S.  If not, see <http://www.gnu.org/licenses/>.

SUBROUTINE SETUP_CPAT_VPAT (STR, NAT)

USE PARAMETERS

IMPLICIT NONE

INTEGER, INTENT(IN) :: STR, NAT
INTEGER :: RAB, RAC, RAD

  do RAB=1, NAT
    CPAT(RAB) = 0
    if (CONTJ(RAB,STR) .gt. 1) then
      RAC = 0
      do RAD=1, CONTJ(RAB,STR)
        if (CONTJ(VOISJ(RAD,RAB,STR),STR) .gt. 1) then
          RAC=RAC+1
          VPAT(RAB,RAC) = VOISJ(RAD,RAB,STR)
        endif
      enddo
      if (RAC .ge. 2) then
        CPAT(RAB) = RAC
      endif
    endif
  enddo

END SUBROUTINE

INTEGER FUNCTION RINGS()

USE PARAMETERS

DOUBLE PRECISION :: pro

INTERFACE
  INTEGER FUNCTION RECRINGS(VES)
    INTEGER, INTENT(IN) :: VES
  END FUNCTION
END INTERFACE

RINGS=0

! Dynamic allocation of pointers and tables used in the "RINGS" subroutine

do i=1, NS

  if (NS .gt. 1) then
    pro=(i-1)/(1.0*NS)
    call setprogress (pro)
  endif

  do j=1, TAILLD
  do k=1, NUMA
  do n=1, TAILLD
    RINGSAVED(j,k,n)=0
  enddo
  enddo
  enddo

  call SETUP_CPAT_VPAT (i, NA)

  o=0

  do j=1, NA

! All Atoms do-loop
    if (NS .eq. 1 .and. TAILLD.ge.20) then
      pro=(j-1)/(1.0*NA)
      call setprogress (pro)
    endif

    if (TLT .eq. NSP+1 .or. LOT(j) .eq. TLT) then

      o=o+1
      do k=1, NA
        RPAT(k) = 0
      enddo

      do k=1, TAILLD
        APNA(k)=0
      enddo
      MINAT=TAILLD
      MAXAT=1
      SAUT=.true.

      do l=1, CPAT(j)-1

        do m=l+1, CPAT(j)

          if (ABAB) then
            LOA=LOT(j)
            LOB=LOT(VPAT(j,l))
            LOC=LOT(VPAT(j,m))
            if ((LOB .ne. LOA) .and. (LOC .ne. LOA) .and. (LOB .eq. LOC)) then
              RUNSEARCH=.true.
            else
              RUNSEARCH=.false.
            endif
          else
            RUNSEARCH=.true.
          endif

          if (RUNSEARCH) then

            FOUND=.false.
            do k=1, CPAT(j)
              RPAT(VPAT(j,k)) = 1
            enddo
            RPAT(VPAT(j,l))=0

            call CREAT_LIST(VPAT(j,l), 1)
            ANNEAUX => FIRST
            call DO_LIST(j, 1)

            TAILLE=TAILLD
            TAILLH=TAILLD-1
            do k=1, TAILLD
              RES_LIST(k)=0
              do n=1, NUMA
                INDR(k,n)=0
              enddo
            enddo

            call DO_LIST(VPAT(j,m), CPAT(VPAT(j,m)))
            call INSIDE_LIST(i, VPAT(j,m))
            if (TBR .or. ALC) goto 001
            call CLEAN_LIST(ANNEAUX%INDICE)
            if (APNA(TAILLE) .eq. 0 .and. TAILLE .lt. TAILLD) then
              APNA(TAILLE)=1
              MINAT=min(MINAT,TAILLE)
              MAXAT=max(MAXAT,TAILLE)
              if (FACTATPNA) ATPNA(TAILLE,o,i)=1
              SAUT=.false.
            elseif (APNA(TAILLE) .eq. 0) then
              do k=1, NRING(TAILLE,i)
                if (INDR(TAILLE,k) .ne. 0) then
                  APNA(TAILLE)=1
                  MINAT=min(MINAT,TAILLE)
                  MAXAT=max(MAXAT,TAILLE)
                  if (FACTATPNA) ATPNA(TAILLE,o,i)=1
                  SAUT=.false.
                  exit
                endif
              enddo
            endif
            do k=1, NRING(TAILLE,i)
              if (FACTATRING) ATRING(TAILLE,o,i)=ATRING(TAILLE,o,i)+INDR(TAILLE,k)
              INDRING(TAILLE,k,i)=INDRING(TAILLE,k,i)+INDR(TAILLE,k)
            enddo
            do k=1, NRING(TAILLH,i)
              if (FACTATRING) ATRING(TAILLH,o,i)=ATRING(TAILLH,o,i)+dble(INDR(TAILLH,k))
              INDRING(TAILLH,k,i)=INDRING(TAILLH,k,i)+INDR(TAILLH,k)
            enddo
            if (TAILLE.eq.TAILLD .and. .not.FOUND) then
              if (CONTJ(VPAT(j,l),i) .ge. 2 .and. CONTJ(VPAT(j,m),i) .ge. 2) AMPAT(o,i)=AMPAT(o,i)+1
            endif
          endif
        enddo

      enddo

      if (.not. SAUT) then
        do k=3, TAILLD
          do m=3, TAILLD
            if (APNA(k).eq.1 .and. APNA(m).eq.1) then
              PNA(k,m,i)=PNA(k,m,i)+1
            endif
          enddo
        enddo
        MAXPNA(MAXAT,i)=MAXPNA(MAXAT,i)+1
        MINPNA(MINAT,i)=MINPNA(MINAT,i)+1
      endif
    endif
  enddo

  do l=3, TAILLD

    if (NRING(l,i) .ne. 0) then

      do k=1, NRING(l,i)

        INDRAT(l,i)=INDRAT(l,i)+INDRING(l,k,i)
        FIRR=.false.

        if (mod(INDRING(l,k,i), l) .eq. 0) then
          FIRR=.true.
        elseif (NSP.eq.2 .and. LTLT.ne.0) then
          if (mod(l,2) .eq. 0) then
            if(INDRING(l,k,i) .eq. l/2) then
              FIRR=.true.
            endif
          else
            if(INDRING(l,k,i) .gt. l/2) then
              FIRR=.true.
            endif
          endif
        endif

        if (FIRR) then

          NIRR(l,i)=NIRR(l,i)+1
          NIRRAT(l,i)=NIRRAT(l,i)+INDRING(l,k,i)
          LIRR(l,NIRR(l,i),i)=k

        endif

      enddo

    endif

  enddo

enddo

001 continue

RINGS=RECRINGS(1)

if (NS.gt.1 .or. (NS.eq.1 .and. TAILLD.ge.20)) then
  pro=1.0d0
  call setprogress (pro)
endif

END FUNCTION RINGS

INTEGER FUNCTION CHECK_LISTE(STEP_CHK)

USE PARAMETERS

IMPLICIT NONE

INTEGER, INTENT(IN) :: STEP_CHK
INTEGER :: ix, iy, CHAINE
LOGICAL :: IS_RING=.true.

  LINK_A => FIRST
  LINK_B => FIRST%NEXT
  FIRST%PAST => ANNEAUX
  ANNEAUX%NEXT => FIRST

  if (ANNEAUX%ELEMENT.eq.FIRST%ELEMENT .and. ANNEAUX%INDICE.ge.3) then

    IS_RING=.true.
    HOMO=.false.
    do ix=1, ANNEAUX%INDICE
      if (NSP.gt.1 .and. LOT(LINK_A%ELEMENT).eq.LOT(LINK_B%ELEMENT)) then
        HOMO=.true.
        exit
      endif
      LINK_A => LINK_B
      LINK_B => LINK_A%NEXT
    enddo
    if (PBC) then
      do ix=1,3
        VAR(ix)=0.0d0
      enddo
      LINK_A => FIRST
      LINK_B => LINK_A%NEXT
      do ix=1, ANNEAUX%INDICE
        call CALCRIJ(LINK_A%ELEMENT,LINK_B%ELEMENT,STEP_CHK,STEP_CHK)
        do iy=1,3
          VAR(iy)=VAR(iy)+Rij(iy)
        enddo
        LINK_A => LINK_B
        LINK_B => LINK_A%NEXT
      enddo
      if (abs(VAR(1)) .ge. 0.01 .or. abs(VAR(2)) .ge. 0.01 .or. abs(VAR(3)) .ge. 0.01) then
        IS_RING=.false.
      endif
    endif

    if (IS_RING) then

      CHAINE = ANNEAUX%INDICE

      if (CHAINE .eq. TAILLE) then

        FOUND=.true.
        if (.not.HOMO) then

          call SAVE_RING(TAILLE, STEP_CHK)

        elseif (HOMO .and. CHAINE .lt. TAILLD) then

          if (CHAINE .eq. TAILLH) then
            call SAVE_RING(TAILLH, STEP_CHK)
          elseif (CHAINE .lt. TAILLH) then
            call DEL_RING(TAILLH, STEP_CHK)
            TAILLH = CHAINE
            call SAVE_RING(TAILLH, STEP_CHK)
          endif

        endif

      elseif (CHAINE .lt. TAILLE) then

        FOUND=.true.
        if (HOMO .and. CHAINE .lt. TAILLD) then

          if (CHAINE .eq. TAILLH) then
            call SAVE_RING(TAILLH, STEP_CHK)
          elseif (CHAINE .lt. TAILLH) then
            call DEL_RING(TAILLH, STEP_CHK)
            TAILLH = CHAINE
            call SAVE_RING(TAILLH, STEP_CHK)
          endif

        elseif (.not.HOMO) then

          if (CHAINE .lt. TAILLH) call DEL_RING(TAILLH, STEP_CHK)
          call DEL_RING(TAILLE, STEP_CHK)
          TAILLE = CHAINE
          call SAVE_RING(TAILLE, STEP_CHK)

        endif

      endif

      CHECK_LISTE = 1

    else

      CHECK_LISTE = 2

    endif

  else

    CHECK_LISTE = 0

  endif

END FUNCTION

RECURSIVE SUBROUTINE INSIDE_LIST(S_IL, AI_IL)

USE PARAMETERS

IMPLICIT NONE

INTEGER :: IND, RES
INTEGER, INTENT(IN) :: S_IL, AI_IL

INTERFACE
  INTEGER FUNCTION CHECK_LISTE(STEP_CHK)
    INTEGER, INTENT(IN) :: STEP_CHK
  END FUNCTION
END INTERFACE

if (ANNEAUX%INDICE .lt. TAILLE) then

  do while (ANNEAUX%NEIGHBOR .ge. 1)

    IND = VPAT(AI_IL, ANNEAUX%NEIGHBOR)
    if (RPAT(IND).eq.0 .or. (RPAT(IND).eq.2 .and. ANNEAUX%INDICE .gt.2)) then

      if (ABAB) then
        if ((mod(ANNEAUX%INDICE+1,2) .eq. 0) .and. (LOT(IND) .eq. LOB)) then
          ADDSPEC=.true.
        elseif ((mod(ANNEAUX%INDICE+1,2) .ne. 0) .and. (LOT(IND) .eq. LOA)) then
          ADDSPEC=.true.
        else
          ADDSPEC=.false.
        endif
      else
        ADDSPEC=.true.
      endif

      if (ADDSPEC) then

        call DO_LIST(IND, CPAT(IND))
        RES = CHECK_LISTE(S_IL)
        if (TBR .or. ALC) goto 001
        if (RES .eq. 0) then
          call INSIDE_LIST(S_IL, IND)
          if (TBR .or. ALC) goto 001
        endif
        ANNEAUX => ANNEAUX%PAST
        deallocate(ANNEAUX%NEXT)
        RPAT(IND) = 0

      endif

    endif

    ANNEAUX%NEIGHBOR = ANNEAUX%NEIGHBOR - 1

  enddo

endif

001 continue

END SUBROUTINE INSIDE_LIST

SUBROUTINE SAVE_RING(TLES, S_SAVE)

USE PARAMETERS

IMPLICIT NONE

INTEGER, INTENT(IN) :: TLES, S_SAVE
INTEGER :: idx, idy
LOGICAL :: NEWRING
INTEGER, DIMENSION(:), ALLOCATABLE :: CERCLE, CERCLE2

if (allocated(CERCLE)) deallocate(CERCLE)
allocate(CERCLE(TLES), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Subroutine: SAVE_RING2"//CHAR(0), "Table: CERCLE"//CHAR(0))
  ALC=.true.
  goto 001
endif
if (allocated(CERCLE2)) deallocate(CERCLE2)
allocate(CERCLE2(TLES), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Subroutine: SAVE_RING2"//CHAR(0), "Table: CERCLE2"//CHAR(0))
  ALC=.true.
  goto 001
endif

! A ring has been found, we need to check if it has already been found or not

TMP_SAVE => FIRST

do idx=1, TLES

! Creation of two tab first for the numerical sorting of the list
! The other wihtout sorting for output
  CERCLE(idx)=TMP_SAVE%ELEMENT
  CERCLE2(idx)=TMP_SAVE%ELEMENT
  TMP_SAVE=>TMP_SAVE%NEXT

enddo

call TRI(CERCLE, TLES)
!call SORT3(CERCLE, TLES)

if (NRING(TLES,S_SAVE) .ne. 0) then

  do idx=1, NRING(TLES,S_SAVE)
!   do-loop on existing rings to check if the new on has already been found

    NEWRING=.false.
    do idy=1, TLES
      if (CERCLE(idy) .ne. RINGSAVED(TLES,idx,idy)) then
        NEWRING=.true.
        exit
      endif
    enddo

    if (.not.NEWRING) then

      ! Already been found n-times, increment of the counter
      INDR(TLES,idx)=INDR(TLES,idx)+1
      exit

    endif

  enddo

else

  NEWRING=.true.

endif

if (NEWRING) then

! A new ring has been found
! We save the data

  RES_LIST(TLES)=RES_LIST(TLES)+1
  NRING(TLES,S_SAVE)=NRING(TLES,S_SAVE)+1
  if (NRING(TLES,S_SAVE) .gt. NUMA) then
    TBR=.true.
    goto 001
  endif
  INDR(TLES,NRING(TLES,S_SAVE))=INDR(TLES,NRING(TLES,S_SAVE))+1
  do idx=1, TLES
    RINGSAVED(TLES,NRING(TLES,S_SAVE),idx)=CERCLE(idx)
    RINGORD(TLES,NRING(TLES,S_SAVE),idx,S_SAVE)=CERCLE2(idx)
  enddo

endif

001 continue

if (allocated(CERCLE)) deallocate(CERCLE)
if (allocated(CERCLE2)) deallocate(CERCLE2)

END SUBROUTINE

SUBROUTINE DEL_RING(TLED, S_DEL)

USE PARAMETERS

IMPLICIT NONE

INTEGER, INTENT(IN) :: TLED, S_DEL
INTEGER :: xdel

! The max size of the ring possible for the triplet N1-At-N2 has down
! We have to delete the bigger rings already found for this triplet

if (RES_LIST(TLED) .ge. 1) then

  do xdel=0, RES_LIST(TLED)-1

    do p=1, TAILLD

      RINGSAVED(TLED,NRING(TLED,S_DEL)-xdel,p)=0
      RINGORD(TLED,NRING(TLED,S_DEL)-xdel,p,S_DEL)=0

    enddo

    do p=1, NUMA

      INDR(TLED,p)=0

    enddo

  enddo

  NRING(TLED,S_DEL)=NRING(TLED,S_DEL)-RES_LIST(TLED)
  RES_LIST(TLED)=0

endif

END SUBROUTINE
