! This file is part of I.S.A.A.C.S.
!
! I.S.A.A.C.S. is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! I.S.A.A.C.S. is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with I.S.A.A.C.S.  If not, see <http://www.gnu.org/licenses/>.

INTEGER FUNCTION TRINGS()

USE PARAMETERS

DOUBLE PRECISION :: pro

INTERFACE
  INTEGER FUNCTION RECRINGS(VES)
    INTEGER, INTENT(IN) :: VES
  END FUNCTION
END INTERFACE

TRINGS=0

! Dynamic allocation of pointers and tables used in the "RINGS" subroutine

do i=1, NS

  if (NS .gt. 1) then
    pro=(i-1)/(1.0*NS)
    call setprogress (pro)
  endif

  do j=1, TAILLD
  do k=1, NUMA
  do l=1, TAILLD
  RINGSAVED(j,k,l)=0
  enddo
  enddo
  enddo

  call SETUP_CPAT_VPAT (i, NA)

  o=0
  do j=1, NA

! All Atoms do-loop
    if (NS .eq. 1 .and. TAILLD.ge.20) then
      pro=(j-1)/(1.0*NA)
      call setprogress (pro)
    endif

    if (TLT .eq. NSP+1 .or. LOT(j) .eq. TLT) then

     o=o+1
     do k=1, NA
        RPAT(k) = 0
      enddo
     do k=1, TAILLD
       APNA(k)=0
     enddo
     MINAT=TAILLD
     MAXAT=1
     SAUT=.true.

     do l=1, CPAT(j)-1

        do m=l+1, CPAT(j)

         if (ABAB) then
            LOA=LOT(j)
            LOB=LOT(VPAT(j,l))
            LOC=LOT(VPAT(j,m))
            if ((LOB .ne. LOA) .and. (LOC .ne. LOA) .and. (LOB .eq. LOC)) then
              RUNSEARCH=.true.
            else
              RUNSEARCH=.false.
            endif
          else
            RUNSEARCH=.true.
          endif

          if (RUNSEARCH) then

            do k=1, CPAT(j)
              RPAT(VPAT(j,k)) = 1
            enddo
            RPAT(VPAT(j,l))=0

            call CREAT_LIST(VPAT(j,l), 1)
            ANNEAUX => FIRST
            call DO_LIST(j, 1)

            TAILLE=TAILLD
            do k=1, TAILLD
              RES_LIST(k)=0
              do n=1, NUMA
                INDR(k,n)=0
              enddo
            enddo

            call DO_LIST(VPAT(j,m), CPAT(VPAT(j,m)))
            call INSIDE_LIST_3 (i, VPAT(j,m))
            call CLEAN_LIST(ANNEAUX%INDICE)
            if (TBR .or. ALC) goto 001
            do k=3, TAILLD
              do n=1, NRING(k,i)
                if (INDR(k,n).ne.0 .and. APNA(k).eq.0) then
                  APNA(k)=APNA(k)+1
                  MINAT=min(MINAT,k)
                  MAXAT=max(MAXAT,k)
                  if (FACTATPNA) ATPNA(k,o,i)=1
                  SAUT=.false.
                endif
                if (FACTATRING) ATRING(k,o,i)=ATRING(k,o,i)+INDR(k,n)
                INDRING(k,n,i)=INDRING(k,n,i)+INDR(k,n)
              enddo
            enddo

          endif

        enddo

      enddo

      if(.not. SAUT) then
        do k=3, TAILLD
          do m=3, TAILLD
            if (APNA(k).eq.1 .and. APNA(m).eq.1) then
              PNA(k,m,i)=PNA(k,m,i)+1
            endif
          enddo
        enddo
        MAXPNA(MAXAT,i)=MAXPNA(MAXAT,i)+1
        MINPNA(MINAT,i)=MINPNA(MINAT,i)+1
      endif

    endif

  enddo

  do l=3, TAILLD

    if (NRING(l,i) .ne. 0) then

      do k=1, NRING(l,i)

        INDRAT(l,i)=INDRAT(l,i)+INDRING(l,k,i)
        FIRR=.false.

        if (mod(INDRING(l,k,i), l) .eq. 0) then
          FIRR=.true.
        elseif (NSP.eq.2 .and. LTLT.ne.0) then
          if (mod(l,2) .eq. 0) then
            if(INDRING(l,k,i) .eq. l/2) then
              FIRR=.true.
            endif
          else
            if(INDRING(l,k,i) .gt. l/2) then
              FIRR=.true.
            endif
          endif
        endif

        if (FIRR) then
          NIRR(l,i)=NIRR(l,i)+1
          NIRRAT(l,i)=NIRRAT(l,i)+INDRING(l,k,i)
          LIRR(l,NIRR(l,i),i)=k
        endif

      enddo

    endif

  enddo

enddo

001 continue

TRINGS=RECRINGS(0)

if (NS.gt.1 .or. (NS.eq.1 .and. TAILLD.ge.20)) then
  pro=0.0d0
  call setprogress (pro)
endif

END FUNCTION TRINGS

INTEGER FUNCTION CHECK_LISTE_3(STEP_CHK)

USE PARAMETERS

IMPLICIT NONE

INTEGER, INTENT(IN) :: STEP_CHK
INTEGER :: ix, iy, CHAINE
LOGICAL :: IS_RING=.true.

  LINK_A => FIRST
  LINK_B => FIRST%NEXT
  FIRST%PAST => ANNEAUX
  ANNEAUX%NEXT => FIRST

!   If the last element had to the list is equal to first neighbor and if ring size >4
  if ((ANNEAUX%ELEMENT .eq. FIRST%ELEMENT) .and. (ANNEAUX%INDICE .ge. 3)) then

    HOMO=.false.
    do ix=1, ANNEAUX%INDICE
      if(NSP.gt.1 .and. LOT(LINK_A%ELEMENT).eq.LOT(LINK_B%ELEMENT)) then
        HOMO=.true.
        exit
      endif
      LINK_A => LINK_B
      LINK_B => LINK_A%NEXT
    enddo
    if (PBC) then
      do ix=1,3
        VAR(ix)=0.0d0
      enddo
      LINK_A => FIRST
      LINK_B => LINK_A%NEXT
      FIRST%PAST => ANNEAUX
      ANNEAUX%NEXT => FIRST
      do ix=1, ANNEAUX%INDICE
        call CALCRIJ(LINK_A%ELEMENT,LINK_B%ELEMENT,STEP_CHK,STEP_CHK)
        do iy=1,3
          VAR(iy)=VAR(iy)+Rij(iy)
        enddo
        LINK_A => LINK_B
        LINK_B => LINK_A%NEXT
      enddo
      if (abs(VAR(1)) .lt. 0.01 .and. abs(VAR(2)) .lt. 0.01 .and. abs(VAR(3)) .lt. 0.01) then
        IS_RING=.true.
      else
        IS_RING=.false.
      endif
    endif

    if (IS_RING) then

      CHAINE = ANNEAUX%INDICE

      if (.not.HOMO .or. (HOMO .and. CHAINE .lt. TAILLD)) then
        call SAVE_RING(CHAINE, STEP_CHK)
      endif

      CHECK_LISTE_3 = 1

    else

      CHECK_LISTE_3 = 2

    endif

  else

    CHECK_LISTE_3 = 0

  endif

END FUNCTION

RECURSIVE SUBROUTINE INSIDE_LIST_3(S_IL, AI_IL)

USE PARAMETERS

IMPLICIT NONE

INTEGER :: IND, RES
INTEGER, INTENT(IN) :: S_IL, AI_IL
INTERFACE
  INTEGER FUNCTION CHECK_LISTE_3(STEP_CHK)
    INTEGER, INTENT(IN) :: STEP_CHK
  END FUNCTION
END INTERFACE

if (ANNEAUX%INDICE .lt. TAILLE) then

  do while (ANNEAUX%NEIGHBOR .ge. 1)

    IND = VPAT(AI_IL, ANNEAUX%NEIGHBOR)
    if (RPAT(IND) .eq. 0) then

      if (ABAB) then
        if ((mod(ANNEAUX%INDICE+1,2) .eq. 0) .and. (LOT(IND) .eq. LOB)) then
          ADDSPEC=.true.
        elseif ((mod(ANNEAUX%INDICE+1,2) .ne. 0) .and. (LOT(IND) .eq. LOA)) then
          ADDSPEC=.true.
        else
          ADDSPEC=.false.
        endif
      else
        ADDSPEC=.true.
      endif

      if (ADDSPEC) then

        call DO_LIST(IND, CPAT(IND))
        RES = CHECK_LISTE_3(S_IL)
        if (TBR .or. ALC) goto 001
        if (RES .eq. 0) then
          call INSIDE_LIST_3(S_IL, ANNEAUX%ELEMENT)
          if (TBR .or. ALC) goto 001
        endif
        ANNEAUX => ANNEAUX%PAST
        deallocate(ANNEAUX%NEXT)
        RPAT(IND) = 0

      endif

    endif

    ANNEAUX%NEIGHBOR = ANNEAUX%NEIGHBOR - 1

  enddo

endif

001 continue

END SUBROUTINE INSIDE_LIST_3
