
SUBROUTINE getnspec (nsptrj)

USE PARAMETERS

INTEGER, INTENT(IN) :: nsptrj

NSP=nsptrj

if (allocated(LABEL)) deallocate(LABEL)
allocate (LABEL(NSP), STAT=ERR)
if (ERR .ne. 0) then
  call show_error ("Impossible to allocate memory"//CHAR(0), &
                   "Subroutine: get_nspec"//CHAR(0), "Table: LABEL"//CHAR(0))
endif

END SUBROUTINE

SUBROUTINE getlabel (ids, libs) BIND (C,NAME='getlabel_')

USE PARAMETERS

INTEGER (KIND=c_int), INTENT(IN) :: ids
CHARACTER (KIND=c_char), DIMENSION(*), INTENT(IN) :: libs

do i=1, 2
  LABEL(ids+1)(i:i)=libs(i)
enddo

END SUBROUTINE

INTEGER (KIND=c_int) FUNCTION read_trj (trj_f, ltrj, natrj, nbstrj) BIND (C,NAME='read_trj_')

!
! Lecture of atom types and coordinates - CPMD trajectory
!

USE PARAMETERS

IMPLICIT NONE

LOGICAL :: isok
INTEGER (KIND=c_int), INTENT(IN) :: ltrj, natrj
INTEGER (KIND=c_int), DIMENSION(NSP), INTENT(IN) :: nbstrj
CHARACTER (KIND=c_char), DIMENSION(*), INTENT(IN) :: trj_f
CHARACTER (LEN=ltrj) :: trj_file
INTERFACE
INTEGER FUNCTION TEST_LENGTH(UNITFILE, NATL)
  INTEGER, INTENT(IN) :: UNITFILE, NATL
END FUNCTION
END INTERFACE

do i=1, ltrj
  trj_file(i:i) = trj_f(i)
enddo

inquire (file=trj_file, exist=isok)
if (isok) then

  open (unit=20, file=trj_file, action='read', status='old')
  NS=0
  NA=natrj
  NS=TEST_LENGTH(20, NA)
  if (NS .ge. 1) then
    rewind(20)
    if (allocated(FULLPOS)) deallocate(FULLPOS)
    allocate (FULLPOS(NA,3,NS), STAT=ERR)
    if (ERR .ne. 0) then
      call show_error ("Impossible to allocate memory"//CHAR(0), &
                       "Subroutine: read_trj"//CHAR(0), "Table: FULLPOS"//CHAR(0))
    endif
    if (allocated(TAB_OF_TYPE)) deallocate(TAB_OF_TYPE)
    allocate (TAB_OF_TYPE(NA), STAT=ERR)
    if (ERR .ne. 0) then
      call show_error ("Impossible to allocate memory"//CHAR(0), &
                       "Subroutine: read_trj"//CHAR(0), "Table: TAB_OF_TYPE"//CHAR(0))
    endif
    do i=1, NS
      l=1
      do j=1, NSP
        do k=1, nbstrj(j)
           read (20, *) z, FULLPOS(l,1,i), FULLPOS(l,2,i), FULLPOS(l,3,i)
           ! CPMD trajectory is in atomic units
           do m=1, 3
             FULLPOS(l,m,i)=ANGTOBOHR*FULLPOS(l,m,i)
           enddo
           TAB_OF_TYPE(l)= LABEL(j)
           l=l+1
         enddo
      enddo
    enddo
    read_trj=0
  else
    read_trj=2
  endif

  close(20)

else
  read_trj=1
endif

END FUNCTION
