! This file is part of I.S.A.A.C.S.
!
! I.S.A.A.C.S. is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! I.S.A.A.C.S. is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with I.S.A.A.C.S.  If not, see <http://www.gnu.org/licenses/>.

CHARACTER (LEN=35) FUNCTION legend (nleg, idl)

USE PARAMETERS

INTEGER, INTENT(IN) :: nleg, idl
INTEGER :: DAL, DBL, DCL, DDL, DEL
LOGICAL :: done

legend = ''

if (nleg < GRNUM .or. (nleg > GRNUM+SQNUM+SKNUM-1 .and. nleg < GRNUM+GQNUM+SQNUM+SKNUM)) then

  if (nleg < GRNUM) then
    DEL=nleg
  else
    DEL=nleg-(GRNUM+SQNUM+SKNUM)
  endif
  if (DEL .eq. 0) then
    if (idl .eq. 0) then
      legend = """g(r)[tot] Neutrons"""
    else
      legend = "g(r)[tot] Neutrons"
    endif
  elseif (DEL .eq. 1) then
    if (idl .eq. 0) then
      legend = """g(r)[tot] Neutrons - smoothed"""
    else
      legend = "g(r)[tot] Neutrons - smoothed"
    endif
  elseif (DEL .eq. 2) then
    if (idl .eq. 0) then
      legend = """G(r)[tot] Neutrons"""
    else
      legend = "G(r)[tot] Neutrons"
    endif
  elseif (DEL .eq. 3) then
    if (idl .eq. 0) then
      legend = """G(r)[tot] Neutrons - smoothed"""
    else
      legend = "G(r)[tot] Neutrons - smoothed"
    endif
  elseif (DEL .eq. 4) then
    if (idl .eq. 0) then
      legend = """g(r)[tot] X-rays"""
    else
      legend = "g(r)[tot] X-rays"
    endif
  elseif (DEL .eq. 5) then
    if (idl .eq. 0) then
      legend = """g(r)[tot] X-rays - smoothed"""
    else
      legend = "g(r)[tot] X-rays - smoothed"
    endif
  elseif (DEL .eq. 6) then
    if (idl .eq. 0) then
      legend = """G(r)[tot] X-rays"""
    else
      legend = "G(r)[tot] X-rays"
    endif
  elseif (DEL .eq. 7) then
    if (idl .eq. 0) then
      legend = """G(r)[tot] X-rays - smoothed"""
    else
      legend = "G(r)[tot] X-rays - smoothed"
    endif
  elseif (DEL .ge. 8) then
    DCL=7
    done=.false.
    do DAL=1, NSP
      do DBL=1, NSP
        DCL=DCL+1
        if (DCL.eq.DEL) then
          if (idl .eq. 0) then
            legend="""g\sij\N(r)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"]"""
          else
            legend="g(r)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"]"
          endif
          done=.true.
          exit
        endif
        DCL=DCL+1
        if (DCL.eq.DEL) then
          if (idl .eq. 0) then
            legend="""g\sij\N(r)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"] - smoothed"""
          else
            legend="g(r)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"] - smoothed"
          endif
          done=.true.
          exit
        endif
        DCL=DCL+1
        if (DCL.eq.DEL) then
          if (idl .eq. 0) then
            legend="""G\sij\N(r)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"]"""
          else
            legend="G(r)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"]"
          endif
          done=.true.
          exit
        endif
        DCL=DCL+1
        if (DCL.eq.DEL) then
          if (idl .eq. 0) then
            legend="""G\sij\N(r)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"] - smoothed"""
          else
            legend="G(r)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"] - smoothed"
          endif
          done=.true.
          exit
        endif
        DCL=DCL+1
        if (DCL.eq.DEL) then
          if (idl .eq. 0) then
            legend="""dn\sij\N(r)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"]"""
          else
            legend="dn(r)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"]"
          endif
          done=.true.
          exit
        endif
      enddo
      if(done) exit
    enddo
    if (NSP .eq. 2) then
      DCL=DCL+1
      if (DCL.eq.DEL) then
        if (idl .eq. 0) then
          legend="""BT\sNN\N(r)"""
        else
          legend="BT[NN](r)"
        endif
      endif
      DCL=DCL+1
      if (DCL.eq.DEL) then
        if (idl .eq. 0) then
          legend="""BT\sNN\N(r) - smoothed"""
        else
          legend="BT[NN](r) - smoothed"
        endif
      endif
      DCL=DCL+1
      if (DCL.eq.DEL) then
        if (idl .eq. 0) then
          legend="""BT\sNC\N(r)"""
        else
          legend="BT[NC](r)"
        endif
      endif
      DCL=DCL+1
      if (DCL.eq.DEL) then
        if (idl .eq. 0) then
          legend="""BT\sNC\N(r) - smoothed"""
        else
          legend="BT[NC](r) - smoothed"
        endif
      endif
      DCL=DCL+1
      if (DCL.eq.DEL) then
        if (idl .eq. 0) then
          legend="""BT\sCC\N(r)"""
        else
          legend="BT[CC](r)"
        endif
      endif
      DCL=DCL+1
      if (DCL.eq.DEL) then
        if (idl .eq. 0) then
          legend="""BT\sCC\N(r) - smoothed"""
        else
          legend="BT[CC](r) - smoothed"
        endif
      endif
    endif
  endif

else if (nleg < GRNUM+SQNUM+SKNUM) then

  if (nleg - (GRNUM+SQNUM) < 0) then
    DDL = nleg - GRNUM
  else
    DDL = nleg - GRNUM-SQNUM
  endif
  if (DDL .eq. 0) then
    if (idl .eq. 0) then
      legend = """S(q)[total] Neutrons"""
    else
      legend = "S(q)[total] Neutrons"
    endif
  elseif (DDL .eq. 1) then
    if (idl .eq. 0) then
      legend = """S(q) Neutrons - smoothed"""
    else
      legend = "S(q) Neutrons - smoothed"
    endif
  elseif (DDL .eq. 2) then
    if (idl .eq. 0) then
      legend = """Q(q)[total] Neutrons"""
    else
      legend = "Q(q)[total] Neutrons"
    endif
  elseif (DDL .eq. 3) then
    if (idl .eq. 0) then
      legend = """Q(q)[total] Neutrons - smoothed"""
    else
      legend = "Q(q)[total] Neutrons - smoothed"
    endif
  elseif (DDL .eq. 4) then
    if (idl .eq. 0) then
      legend = """S(q)[total] X-rays"""
    else
      legend = "S(q)[total] X-rays"
    endif
  elseif (DDL .eq. 5) then
    if (idl .eq. 0) then
      legend = """S(q) X-rays - smoothed"""
    else
      legend = "S(q) X-rays - smoothed"
    endif
  elseif (DDL .eq. 6) then
    if (idl .eq. 0) then
      legend = """Q(q)[total] X-rays"""
    else
      legend = "Q(q)[total] X-rays"
    endif
  elseif (DDL .eq. 7) then
    if (idl .eq. 0) then
      legend = """Q(q)[total] X-rays - smoothed"""
    else
      legend = "Q(q)[total] X-rays - smoothed"
    endif
  elseif (DDL .ge. 8) then
    DCL=7
    done=.false.
    do DAL=1, NSP
      do DBL=1, NSP
        DCL=DCL+1
        if (DCL.eq.DDL) then
          if (idl .eq. 0) then
            legend="""AL\sij\N(q)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"]"""
          else
            legend="AL (q)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"]"
          endif
          done=.true.
          exit
        endif
        DCL=DCL+1
        if (DCL.eq.DDL) then
          if (idl .eq. 0) then
            legend="""AL\sij\N(q)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"] - smoothed"""
          else
            legend="AL (q)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"] - smoothed"
          endif
          done=.true.
          exit
        endif
      enddo
      if(done) exit
    enddo
    do DAL=1, NSP
      do DBL=1, NSP
        DCL=DCL+1
        if (DCL.eq.DDL) then
          if (idl .eq. 0) then
            legend="""FZ\sij\N(q)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"]"""
          else
            legend="FZ N(q)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"]"
          endif
          done=.true.
          exit
        endif
        DCL=DCL+1
        if (DCL.eq.DDL) then
          if (idl .eq. 0) then
            legend="""FZ\sij\N(q)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"] - smoothed"""
          else
            legend="FZ N(q)["// &
            TL(DAL)(1:LEN_TRIM(TL(DAL)))//","//TL(DBL)(1:LEN_TRIM(TL(DBL)))//"] - smoothed"
          endif
          done=.true.
          exit
        endif
      enddo
      if(done) exit
    enddo
    if (NSP .eq. 2) then
      DCL=DCL+1
      if (DCL.eq.DDL) then
        if (idl .eq. 0) then
          legend="""BT\sNN\N(q)"""
        else
          legend="BT[NN](q)"
        endif
      endif
      DCL=DCL+1
      if (DCL.eq.DDL) then
        if (idl .eq. 0) then
          legend="""BT\sNN\N(q) - smoothed"""
        else
          legend="BT[NN](q) - smoothed"
        endif
      endif
      DCL=DCL+1
      if (DCL.eq.DDL) then
        if (idl .eq. 0) then
          legend="""BT\sNC\N(q)"""
        else
          legend="BT[NC](q)"
        endif
      endif
      DCL=DCL+1
      if (DCL.eq.DDL) then
        if (idl .eq. 0) then
          legend="""BT\sNC\N(q) - smoothed"""
        else
          legend="BT[NC](q) - smoothed"
        endif
      endif
      DCL=DCL+1
      if (DCL.eq.DDL) then
        if (idl .eq. 0) then
          legend="""BT\sCC\N(q)"""
        else
          legend="BT[CC](q)"
        endif
      endif
     DCL=DCL+1
      if (DCL.eq.DDL) then
        if (idl .eq. 0) then
          legend="""BT\sCC\N(q) - smoothed"""
        else
          legend="BT[CC](q) - smoothed"
        endif
      endif
      DCL=DCL+1
      if (DCL.eq.DDL) then
        if (idl .eq. 0) then
          legend="""BT\sZZ\N(q)"""
        else
          legend="BT[ZZ](q)"
        endif
      endif
      DCL=DCL+1
      if (DCL.eq.DDL) then
        if (idl .eq. 0) then
          legend="""BT\sZZ\N(q) - smoothed"""
        else
          legend="BT[ZZ](q) - smoothed"
        endif
      endif
    endif
  endif

else if (nleg < GRNUM+GQNUM+SQNUM+SKNUM+BDNUM) then

  DDL = GRNUM+GQNUM+SQNUM+SKNUM
  do DAL=1, NSP
    do DBL=1, NSP
      if (nleg .eq. DDL) then
        if (idl .eq. 0) then
          legend = """% Dij ["//TL(DAL)(1:LEN_TRIM(TL(DAL)))//"-" &
          //TL(DBL)(1:LEN_TRIM(TL(DBL)))//"]"""
          done=.true.
          exit
        else
          legend = "% Dij ["//TL(DAL)(1:LEN_TRIM(TL(DAL)))//"-" &
          //TL(DBL)(1:LEN_TRIM(TL(DBL)))//"]"
          done=.true.
          exit
        endif
      endif
      DDL=DDL+1
    enddo
  enddo

else if (nleg < GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM) then

  DDL = GRNUM+GQNUM+SQNUM+SKNUM+BDNUM
  do DAL=1, NSP
    do DBL=1, NSP
      do DCL=1, NSP
        if (nleg .eq. DDL) then
          if (idl .eq. 0) then
            legend = """% Angle ["//TL(DAL)(1:LEN_TRIM(TL(DAL)))//"-" &
            //TL(DBL)(1:LEN_TRIM(TL(DBL)))//"-"//TL(DCL)(1:LEN_TRIM(TL(DCL)))//"]"""
          else
            legend = "% Angle ["//TL(DAL)(1:LEN_TRIM(TL(DAL)))//"-" &
            //TL(DBL)(1:LEN_TRIM(TL(DBL)))//"-"//TL(DCL)(1:LEN_TRIM(TL(DCL)))//"]"
          endif
        endif
        DDL=DDL+1
      enddo
    enddo
  enddo
  do DAL=1, NSP
    do DBL=1, NSP
      do DCL=1, NSP
        do DEL=1, NSP
          if (nleg .eq. DDL) then
            if (idl .eq. 0) then
              legend = """% Diedral ["// &
              TL(DAL)(1:LEN_TRIM(TL(DAL)))//"-"//TL(DBL)(1:LEN_TRIM(TL(DBL)))// &
              "-"//TL(DCL)(1:LEN_TRIM(TL(DCL)))//"-"//TL(DEL)(1:LEN_TRIM(TL(DEL)))//"]"""
            else
              legend = "% Diedral ["// &
              TL(DAL)(1:LEN_TRIM(TL(DAL)))//"-"//TL(DBL)(1:LEN_TRIM(TL(DBL)))// &
              "-"//TL(DCL)(1:LEN_TRIM(TL(DCL)))//"-"//TL(DEL)(1:LEN_TRIM(TL(DEL)))//"]"
            endif
          endif
          DDL=DDL+1
        enddo
      enddo
    enddo
  enddo

else if (nleg < GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM) then

  DDL = nleg-(GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM)
  if (DDL.eq.0 .or. DDL.eq.4 .or. DDL.eq.8 .or. DDL.eq.12 .or. DDL.eq.16) then
    if (idl .eq. 0) then
      legend= """R\sc\N(\f{Times-Italic}n\f{})"""
    else
      legend= "Rc(n)"
    endif
  elseif (DDL.eq.1 .or. DDL.eq.5 .or. DDL.eq.9 .or. DDL.eq.13 .or. DDL.eq.17) then
    if (idl .eq. 0) then
      legend= """P\sn\N(\f{Times-Italic}n\f{})"""
    else
      legend= "Pn(n)"
    endif
  elseif (DDL.eq.2 .or. DDL.eq.6 .or. DDL.eq.10 .or. DDL.eq.14 .or. DDL.eq.18) then
    if (idl .eq. 0) then
      legend= """P\smax\N(\f{Times-Italic}n\f{})"""
    else
      legend= "Pmax(n)"
    endif
  elseif (DDL.eq.3 .or. DDL.eq.7 .or. DDL.eq.11 .or. DDL.eq.15 .or. DDL.eq.19) then
    if (idl .eq. 0) then
      legend= """P\smin\N(\f{Times-Italic}n\f{})"""
    else
      legend= "Pmin(n)"
    endif
  endif

elseif (nleg < GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM+SHNUM) then

  DDL = nleg-(GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM)
!  if (DDL .eq. 0) then
!    if (idl .eq. 0) then
!      legend= """Q\sl\N [average]"""
!    else
!      legend= "Ql [average]"
!    endif
  if (DDL.le.NSP-1) then
    do DEL=1, NSP
      if (idl .eq. 0) then
        legend= """Q\sl\N ["//TL(DEL)(1:LEN_TRIM(TL(DEL)))//" atoms]"""
      else
        legend= "Ql ["//TL(DEL)(1:LEN_TRIM(TL(DEL)))//" atoms]"
      endif
    enddo
  else
    if (idl .eq. 0) then
      legend= """Q\sl\N specific environment"""
    else
      legend= "Ql specific environment"
    endif
  endif

else

  DDL = GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM+SHNUM
  do DAL=1, NSP
    if (nleg .eq. DDL) then
      if (idl .eq. 0) then
        legend= """MSD ("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [\cE\C\S2\N]"""
      else
        legend= "MSD ("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [Å²]"
      endif
    endif
    DDL=DDL+1
    if (nleg .eq. DDL) then
      if (idl .eq. 0) then
        legend= """MSD nac ("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [\cE\C\S2\N]"""
      else
        legend= "MSD nac ("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [Å²]"
      endif
    endif
    DDL=DDL+1
  enddo
  do DAL=1, NSP
    if (nleg .eq. DDL) then
      if (idl .eq. 0) then
        legend= """MSD [x]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [\cE\C\S2\N]"""
      else
        legend= "MSD [x]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [Å²]"
      endif
    endif
    DDL=DDL+1
    if (nleg .eq. DDL) then
      if (idl .eq. 0) then
        legend= """MSD [y]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [\cE\C\S2\N]"""
      else
        legend= "MSD [y]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [Å²]"
      endif
    endif
    DDL=DDL+1
    if (nleg .eq. DDL) then
      if (idl .eq. 0) then
        legend= """MSD [z]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [\cE\C\S2\N]"""
      else
        legend= "MSD [z]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [Å²]"
      endif
    endif
    DDL=DDL+1
    if (nleg .eq. DDL) then
      if (idl .eq. 0) then
        legend= """MSD [xy]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [\cE\C\S2\N]"""
      else
        legend= "MSD [xy]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [Å²]"
      endif
    endif
    DDL=DDL+1
    if (nleg .eq. DDL) then
      if (idl .eq. 0) then
        legend= """MSD [xz]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [\cE\C\S2\N]"""
      else
        legend= "MSD [xz]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [Å²]"
      endif
    endif
    DDL=DDL+1
    if (nleg .eq. DDL) then
      if (idl .eq. 0) then
        legend= """MSD [yz]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [\cE\C\S2\N]"""
      else
        legend= "MSD [yz]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [Å²]"
      endif
    endif
    DDL=DDL+1
  enddo
  do DAL=1, NSP
    if (nleg .eq. DDL) then
      if (idl .eq. 0) then
        legend= """MSD [x/nac]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [\cE\C\S2\N]"""
      else
        legend= "MSD [x/nac]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [Å²]"
      endif
    endif
    DDL=DDL+1
    if (nleg .eq. DDL) then
      if (idl .eq. 0) then
        legend= """MSD [y/nac]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [\cE\C\S2\N]"""
      else
        legend= "MSD [y/nac]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [Å²]"
      endif
    endif
    DDL=DDL+1
    if (nleg .eq. DDL) then
      if (idl .eq. 0) then
        legend= """MSD [z/nac]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [\cE\C\S2\N]"""
      else
        legend= "MSD [z/nac]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [Å²]"
      endif
    endif
    DDL=DDL+1
    if (nleg .eq. DDL) then
      if (idl .eq. 0) then
        legend= """MSD [xy/nac]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [\cE\C\S2\N]"""
      else
        legend= "MSD [xy/nac]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [Å²]"
      endif
    endif
    DDL=DDL+1
    if (nleg .eq. DDL) then
      if (idl .eq. 0) then
        legend= """MSD [xz/nac]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [\cE\C\S2\N]"""
      else
        legend= "MSD [xz/nac]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [Å²]"
      endif
    endif
    DDL=DDL+1
    if (nleg .eq. DDL) then
      if (idl .eq. 0) then
        legend= """MSD [yz/nac]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [\cE\C\S2\N]"""
      else
        legend= "MSD [yz/nac]("//TL(DAL)(1:LEN_TRIM(TL(DAL)))//") [Å²]"
      endif
    endif
    DDL=DDL+1
  enddo
  if (nleg .eq. DDL) then
    if (idl .eq. 0) then
      legend= """Correction (x) [\cE\C\S2\N]"""
    else
      legend= "Correction (x) [Å²]"
    endif
  endif
  DDL=DDL+1
  if (nleg .eq. DDL) then
    if (idl .eq. 0) then
      legend= """Correction (y) [\cE\C\S2\N]"""
    else
      legend= "Correction (y) [Å²]"
    endif
  endif
  DDL=DDL+1
  if (nleg .eq. DDL) then
    if (idl .eq. 0) then
      legend= """Correction (z) [\cE\C\S2\N]"""
    else
      legend= "Correction (z) [Å²]"
    endif
  endif
  DDL=DDL+1
  if (nleg .eq. DDL) then
    if (idl .eq. 0) then
      legend= """Drift (x) [ms\S-1\N]"""
    else
      legend= "Drift (x) m/s"
    endif
  endif
  DDL=DDL+1
  if (nleg .eq. DDL) then
    if (idl .eq. 0) then
      legend= """Drift (y) [ms\S-1\N]"""
    else
      legend= "Drift (y) (m/s)"
    endif
  endif
  DDL=DDL+1
  if (nleg .eq. DDL) then
    if (idl .eq. 0) then
      legend= """Drift (z) [ms\S-1\N]"""
    else
      legend= "Drift (z) (m/s)"
    endif
  endif

endif

END FUNCTION

CHARACTER (LEN=65) FUNCTION xlegend (nleg, idl, cdc)

USE PARAMETERS

INTEGER, INTENT(IN) :: nleg, idl
DOUBLE PRECISION, INTENT(IN) :: cdc
INTEGER :: il
CHARACTER (LEN=6), DIMENSION(5) :: tpsunit = (/'t [fs]', 't [ps]', 't [ns]', 't [us]', 't [ms]' /)
INTERFACE
  CHARACTER (LEN=7) FUNCTION getunit()
  END FUNCTION
END INTERFACE

xlegend = ''
if (idl .eq. 0) then
  if (nleg .lt. GRNUM) then
    xlegend = "r[\cE\C]"""
  elseif (nleg .lt. GRNUM+SQNUM+SKNUM) then
    xlegend = "q[\cE\C\S-1\N]"""
  elseif (nleg .lt. GRNUM+GQNUM+SQNUM+SKNUM) then
    xlegend = "r[\cE\C]"""
  elseif (nleg .lt. GRNUM+GQNUM+SQNUM+SKNUM+BDNUM) then
    xlegend = "Dij[\cE\C\]"""
  elseif (nleg .lt. GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM) then
    if ( nleg .lt. GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+NSP*NSP*NSP ) then
      xlegend = "Angles[\c:\C]"""
    else
      xlegend = "Dihedrals[\c:\C]"""
    endif
  elseif (nleg .lt. GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM) then
    xlegend = "Size \f{Times-Italic}n\f{} of the rings [total number of nodes]"""
  elseif (nleg .lt. GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM+SHNUM) then
    xlegend = "Q\sl\N"""
  else
    il = AnINT(cdc)
    if (il .eq. 4) then
      xlegend = "\f{12}m\f{}"""
    else
      xlegend = tpsunit(il)//""""
    endif
  endif
else
  if (nleg .lt. GRNUM) then
    xlegend = "r[Å]"
  elseif (nleg .lt. GRNUM+SQNUM+SKNUM+BDNUM) then
    xlegend = "q[Å-1]"
  elseif (nleg .lt. GRNUM+GQNUM+SQNUM+SKNUM+BDNUM) then
    xlegend = "r[Å]"
  elseif (nleg .lt. GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM) then
    if ( nleg .lt. GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+NSP*NSP*NSP ) then
      xlegend = "Angles[°]"
    else
      xlegend = "Dihedrals[°]"
    endif
  elseif (nleg .lt. GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM) then
    xlegend = "Size n of the rings [total number of nodes]"
  elseif (nleg .lt. GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM+SHNUM) then
    xlegend = "Ql"
  else
    il = AnINT(cdc)
    xlegend = tpsunit(il)
  endif
endif

END FUNCTION

SUBROUTINE prep_file (scf, sfi, tfile, scalex, scaley, mdc, idc) BIND (C,NAME='prep_file_')

USE PARAMETERS

INTEGER (KIND=c_int), INTENT(IN) :: scf, idc, tfile
INTEGER (KIND=c_int), INTENT(IN) :: scalex, scaley
CHARACTER (KIND=c_char), DIMENSION(*), INTENT(IN) :: sfi
CHARACTER (LEN=scf) :: sfile
REAL (KIND=c_double), INTENT(IN) :: mdc
CHARACTER (LEN=5) :: xaxis="xaxis", yaxis="yaxis"
CHARACTER (LEN=65) :: xlabel
INTERFACE
  CHARACTER(LEN=65) FUNCTION xlegend (nleg, idl, cdc)
    INTEGER, INTENT(IN) :: nleg, idl
    DOUBLE PRECISION, INTENT(IN) :: cdc
  END FUNCTION
END INTERFACE

xlabel = xlegend(idc, tfile, mdc)

do i=1, scf
  sfile(i:i) = sfi(i)
enddo

open(unit=200, file=sfile, action="write", status='unknown')
if (tfile .eq. 0) then
  write (200, 001)
  write (200, 002) xaxis, xlabel
  write (200, 003) xaxis
  if (scalex .eq. 1) write (200, 016)
  write (200, 004) xaxis, 1.0
  write (200, 005) xaxis, 0.5
  write (200, 007) xaxis
  write (200, 008) xaxis
  write (200, 003) yaxis
  if (scaley .eq. 1) write (200, 017)
  write (200, 004) yaxis, 1.0
  write (200, 005) yaxis, 0.5
  write (200, 007) yaxis
  write (200, 008) yaxis
  write (200, 009)
  write (200, 010)
endif

001 FORMAT ("@with g0")
002 FORMAT ("@    ",A5," label """,A65)
003 FORMAT ("@    ",A5," tick on")
004 FORMAT ("@    ",A5," tick major size ",f8.6)
005 FORMAT ("@    ",A5," tick minor size ",f8.6)
007 FORMAT ("@    ",A5," ticklabel on")
008 FORMAT ("@    ",A5," ticklabel char size 0.800000")
009 FORMAT ("@    legend on")
010 FORMAT ("@    legend box linestyle 0")
016 FORMAT ("@    xaxes scale Logarithmic")
017 FORMAT ("@    yaxes scale Logarithmic")

END SUBROUTINE

SUBROUTINE append_to_file (ssize, sdata, tdata, ddc, mdc, idc, tfile, nfile, afile)

USE PARAMETERS

INTEGER, INTENT(IN) :: idc
INTEGER, INTENT(IN) :: tdata
INTEGER, INTENT(IN) :: tfile
INTEGER, INTENT(IN) :: nfile
INTEGER, INTENT(IN) :: afile
INTEGER, INTENT(IN) :: ssize
INTEGER :: AB
DOUBLE PRECISION, DIMENSION(ssize), INTENT(IN) :: sdata
DOUBLE PRECISION, INTENT(IN) :: ddc, mdc
CHARACTER (LEN=65) :: xlabel
CHARACTER (LEN=35) :: ylabel
INTERFACE
  CHARACTER(LEN=65) FUNCTION xlegend (nleg, idl, cdc)
    INTEGER, INTENT(IN) :: nleg, idl
    DOUBLE PRECISION, INTENT(IN) :: cdc
  END FUNCTION
  CHARACTER (LEN=35) FUNCTION legend (nleg, idl)
    INTEGER, INTENT(IN) :: nleg, idl
  END FUNCTION
END INTERFACE

ylabel = legend(idc, tfile)
xlabel = xlegend(idc, tfile, mdc)

if (tfile .eq. 0) then
  call CHARINT(Nom, nfile)
  write (200, *) "@target G0.S",Nom(2:LEN_TRIM(Nom))
  write (200, *) "@s",Nom(2:LEN_TRIM(Nom))," legend ",ylabel
  if (tdata .eq. 1) then
    write (200, *) "@s",Nom(2:LEN_TRIM(Nom))," line linestyle 0"
    write (200, 019)
  else
    write (200, 013)
  endif
else
  write (200, 015) xlabel, ylabel
endif

if (idc.ge.GRNUM+SQNUM .and. idc.lt.GRNUM+SQNUM+SKNUM) then
  do AB=1, ssize
    if (sdata(AB) .ne. -999999.0) write (200, 014) mdc+(AB-1)*ddc, sdata(AB)
  enddo
else if (idc.lt.GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM .and. idc.ge.GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM) then
  do AB=3, ssize
    write (200, 014) AB*ddc, sdata(AB)
  enddo
else if (idc.lt.GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM+SHNUM .and. idc.ge.GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM) then
  do AB=1, ssize, 2
    if (sdata(AB) .ne. 0) then
      write (200, 014) AB*ddc, sdata(AB)
    endif
  enddo
else if (idc .ge. GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM+SHNUM ) then
  do AB=1, ssize
    write (200, 014) AB*ddc, sdata(AB)
  enddo
else
  do AB=1, ssize
    write (200, 014) mdc+(AB-0.5)*ddc, sdata(AB)
  enddo
endif
write (200, *)

if (nfile  .eq. afile-1) close(200)

013 FORMAT ("@type xy")
014 FORMAT (f20.10,3x,f20.10)
015 FORMAT ("# ",A65," ",A35)
019 FORMAT ("@type bar")

END SUBROUTINE

SUBROUTINE save_to_file (scf, sfi, ssize, sdata, &
                         scalex, scaley, tdata, &
                         ddc, mdc, idc, tfile) BIND (C,NAME='save_to_file_')

USE PARAMETERS

INTEGER (KIND=c_int), INTENT(IN) :: scf, idc, tfile
INTEGER (KIND=c_int), INTENT(IN) :: ssize, scalex, scaley, tdata
CHARACTER (KIND=c_char), DIMENSION(*), INTENT(IN) :: sfi
CHARACTER (LEN=scf) :: sfile
REAL (KIND=c_double), INTENT(IN) :: ddc, mdc
REAL (KIND=c_double), DIMENSION(ssize), INTENT(IN) :: sdata
INTEGER :: tit
INTEGER :: AB, AC
CHARACTER (LEN=5) :: xaxis="xaxis", yaxis="yaxis"
CHARACTER (LEN=65) :: xlabel
CHARACTER (LEN=35) :: ylabel
INTERFACE
  CHARACTER(LEN=65) FUNCTION xlegend (nleg, idl, cdc)
    INTEGER, INTENT(IN) :: nleg, idl
    DOUBLE PRECISION, INTENT(IN) :: cdc
  END FUNCTION
  CHARACTER (LEN=35) FUNCTION legend (nleg, idl)
    INTEGER, INTENT(IN) :: nleg, idl
  END FUNCTION
END INTERFACE

ylabel = legend(idc, tfile)
xlabel = xlegend(idc, tfile, mdc)

do i=1, scf
  sfile(i:i) = sfi(i)
enddo

open(unit=100, file=sfile, action="write", status='unknown')

if (tfile .eq. 0) then
  write (100, 001)
  write (100, 002) xaxis, xlabel
  write (100, 003) xaxis
  tit=GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM+SHNUM
  if (scalex .eq. 1) write (100, 016)
  write (100, 004) xaxis, 1.0
  write (100, 005) xaxis, 0.5
  write (100, 007) xaxis
  write (100, 008) xaxis
  write (100, 006) yaxis, ylabel
  write (100, 003) yaxis
  if (scaley .eq. 1) write (100, 017)
  write (100, 004) yaxis, 1.0
  write (100, 005) yaxis, 0.5
  write (100, 007) yaxis
  write (100, 008) yaxis
  write (100, 009)
  write (100, 010)
  if (idc.lt.GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM .and. idc.ge.GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM) then
    tit=idc-(GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM)
    if (tdata .eq. 1) then
      AC=0
      do AB=3, ssize
        if (sdata(AB) .ne. 0) then
          call CHARINT(Nom, AC)
          call CHARINT(Nom2, AB)
          write (100, *) "@    s",Nom(2:LEN_TRIM(Nom))," legend  ""t",Nom2(2:LEN_TRIM(Nom2)),""""
          write (100, *) "@    s",Nom(2:LEN_TRIM(Nom))," line linestyle 0"
          write (100, *) "@    s",Nom(2:LEN_TRIM(Nom))," symbol fill pattern 14"
          AC=AC+1
        endif
      enddo
      AC=0
      do AB=3, ssize
        if (sdata(AB) .ne. 0) then
          call CHARINT(Nom, AC)
          write (100, *) "@target G0.S",Nom(2:LEN_TRIM(Nom))
          write (100, 019)
          write (100, 018) AB, sdata(AB)
          AC=AC+1
        endif
      enddo
    else
      write (100, 011) ylabel
      write (100, 012)
      write (100, 013)
      do AB=3, ssize
        if (sdata(AB) .ne. 0.0) write (100, 018) AB, sdata(AB)
      enddo
    endif
  elseif (idc.lt.GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM+SHNUM .and. idc.ge.GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM) then
    if (tdata .eq. 1) then
      AC=0
      do AB=1, ssize, 2
        if (sdata(AB) .ne. 0) then
          call CHARINT(Nom, AC)
          call CHARINT(Nom2, AB-1)
          write (100, *) "@    s",Nom(2:LEN_TRIM(Nom))," legend  ""t",Nom2(2:LEN_TRIM(Nom2)),""""
          write (100, *) "@    s",Nom(2:LEN_TRIM(Nom))," line linestyle 0"
          write (100, *) "@    s",Nom(2:LEN_TRIM(Nom))," symbol fill pattern 14"
          AC=AC+1
        endif
      enddo
      AC=0
      do AB=1, ssize, 2
        if (sdata(AB) .ne. 0) then
          call CHARINT(Nom, AC)
          write (100, *) "@target G0.S",Nom(2:LEN_TRIM(Nom))
          write (100, 019)
          write (100, 018) AB, sdata(AB)
          AC=AC+1
        endif
      enddo
    else
      write (100, 011) ylabel
      write (100, 012)
      write (100, 013)
      do AB=0, ssize, 2
        write (100, 018) AB, sdata(AB)
      enddo
    endif
  elseif (idc.ge.GRNUM+SQNUM .and. idc.lt.GRNUM+SQNUM+SKNUM) then
    write (100, 011) ylabel
    write (100, 012)
    write (100, 013)
    do AB=1, ssize
      if (sdata(AB) .ne. -999999.0) write (100, 014) mdc+(AB-1)*ddc, sdata(AB)
    enddo
  else
    if (tdata .eq. 0) then
      write (100, 011) ylabel
      write (100, 012)
      write (100, 013)
    else
      write (100, 011) ylabel
      write (100, 012)
      write (100, 019)
    endif
    do AB=1, ssize
      write (100, 014) mdc+(AB-0.5)*ddc, sdata(AB)
    enddo
  endif
else
  if (idc.ge.GRNUM+SQNUM .and. idc.lt.GRNUM+SQNUM+SKNUM) then
    write (100, 015) xlabel, ylabel
    do AB=1, ssize
      if (sdata(AB) .ne. -999999.0) write (100, 014) mdc+(AB-1)*ddc, sdata(AB)
    enddo
  else if (idc.lt.GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM .and. idc.ge.GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM) then
    write (100, 015) xlabel, ylabel
    do AB=3, ssize
      write (100, 014) AB*ddc, sdata(AB)
    enddo
  else if (idc.lt.GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM+SHNUM .and. idc.ge.GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM) then
    write (100, 015) xlabel, ylabel
    do AB=1, ssize, 2
      if (sdata(AB) .ne. 0) then
        write (100, 014) AB*ddc, sdata(AB)
      endif
    enddo
  else if (idc .ge. GRNUM+GQNUM+SQNUM+SKNUM+BDNUM+ANNUM+RINUM+SHNUM ) then
    write (100, 015) xlabel, ylabel
    do AB=1, ssize
      write (100, 014) AB*ddc, sdata(AB)
    enddo
  else
    write (100, 015) xlabel, ylabel
    do AB=1, ssize
      write (100, 014) mdc+(AB-0.5)*ddc, sdata(AB)
    enddo
  endif
endif
close(100)

001 FORMAT ("@with g0")
002 FORMAT ("@    ",A5," label """,A65)
003 FORMAT ("@    ",A5," tick on")
004 FORMAT ("@    ",A5," tick major size ",f8.6)
005 FORMAT ("@    ",A5," tick minor size ",f8.6)
006 FORMAT ("@    ",A5," label ",A35)
007 FORMAT ("@    ",A5," ticklabel on")
008 FORMAT ("@    ",A5," ticklabel char size 0.800000")
009 FORMAT ("@    legend on")
010 FORMAT ("@    legend box linestyle 0")
011 FORMAT ("@    s0 legend  ",A35)
012 FORMAT ("@target G0.S0")
013 FORMAT ("@type xy")
014 FORMAT (f20.10,3x,f20.10)
015 FORMAT ("# ",A65," ",A35)
016 FORMAT ("@    xaxes scale Logarithmic")
017 FORMAT ("@    yaxes scale Logarithmic")
018 FORMAT (i4,5x,f20.10)
019 FORMAT ("@type bar")

END SUBROUTINE
